# -*- coding: utf-8 -*-
"""
Anagrafiche
===========================

.. autoclass:: GestDipti
   :members:

.. autoclass:: GestDitte
   :members:

"""
__fine_name__ = "__init__.py"
__author__ =    "Luca"
__email__ = "luca.z@essepaghe.it"
__web_site__ = "http://waonline.essepaghe.it"
__version__ =   "1.0.0"
__date__ =      "2012-03-30"
__app_name__ = "anagrafiche"

from waonline.core.rbase                    import RBase

from .gest_dipti                            import GestDipti
from .gest_ditte                            import GestDitte
from .ext                                   import RBaseExt


class Main(RBase):
    """ Gestione Anagrafiche
    """
    def doTask(self, *args, **kwargs):
        method = kwargs['method']
        if hasattr(self, method):
            return RBase.doTask(self, *args, **kwargs)
        else:
            classe = [m for m in self._classi if hasattr(m, method)][0]
            return RBase.doTask(classe(self), *args, **kwargs)

Main._classi = [GestDipti, GestDitte]
Main.extend(RBaseExt)
