# -*- coding: utf-8 -*-
"""
    Estensioni per la classe RBase delle anagrafiche
"""
__fine_name__ = "estensioni.py"
__author__ =    "luca"
__version__ =   "1.0.0"
__date__ =      "2012-05-03"

from ..tabelle                               import ditte
from ..tabelle                               import dipendenti

class RBaseExt(object):
    @property
    def _ditta(self):
        """ Restituisce l'oggetto Ditta in base al codice ditta attuale
            (:data:`_cod_ditta`)
        """
        self.info("ditta: %s codice: %s " % (str(self.__ditta__),
            self._cod_ditta))
        if self.__ditta__ == None:
            if self._cod_ditta:
                query = self._q(ditte.Ditta,
                        ditte.Ditta.codice == self._cod_ditta)
                self.__ditta__ = query.first()
            else:
                self.errore("No cod_ditta!!!")
        return self.__ditta__

    @property
    def _dipti(self):
        """ Restituisce una lista di oggetti Dipendente in base all'id dei
        dipendenti attuali (:data:`_dipti_id`)
        """
        if self.__dipti__ == None and self._dipte_id:
            self.__dipti__ = self._q(dipendenti.Dipendente,
                    dipendenti.Dipendente.id.in_(
                self._dipti_id))
            if self.__dipti__:
                if not self.__dipti__.first():
                    self.__dipti__ = None
        return self.__dipti__

    @property
    def _user_ditteid(self):
        """ ritorna una lista delle ditte esistenti e valide per l'utente """
        if self.__user_ditteid__ == None:
            lditte = self._q(ditte.Ditta.id).group_by(ditte.Ditta.id).filter(
                    ditte.Ditta.codice.in_([c.codice for c in self.user.ditte]))
            self.__user_ditteid__ = [i[0] for i in lditte]
        return self.__user_ditteid__

    def _checkDipe(self, dipte_id):
        """ :func:`_checkDipe` verifica che i dipendenti in dipte_id
        appartengano ad una ditta subordinata all'utente attuale.
        *dipte_id* può essere sia un intero che una lista di interi.

        .. note:: :func:`_checkDipe` in genere è utilizzata da dalle funzioni
           in :mod:`wadecohelpers`.
        """
        valido = True
        if not isinstance(dipte_id, list):
            dipte_id = [dipte_id]
        for dipe_id in [a[0] for a in self._q(dipendenti.Dipendente.ditta_id).\
                group_by(dipendenti.Dipendente.ditta_id).filter(
                    dipendenti.Dipendente.id.in_(dipte_id))]:
            if not dipe_id in self._user_ditteid:
                valido &= False
                break
        return valido
