# -*- coding: utf-8 -*-
"""
Gestione
===========================

.. autoclass:: GestioneInviaRicevi
   :members:

.. autoclass:: GestioneListe 
   :members:

.. autoclass:: GestioneMenu
   :members:

.. autoclass:: Invia
   :members:

.. autoclass:: Ricevi
   :members:


"""
__fine_name__ = "__init__.py"
__author__ =    "Luca"
__email__ = "luca.z@essepaghe.it"
__web_site__ = "http://waonline.essepaghe.it"
__version__ =   "1.0.0"
__date__ =      "2012-05-03"
__app_name__ = "gestione"

from waonline.core.rbase                import RBase
from waonline.apps.anagrafiche.ext      import RBaseExt

from .gest_invia_ricevi          import GestioneInviaRicevi
from .gest_valoriLista           import GestioneListe
from .invia_ricevi_dati          import Ricevi
from .invia_ricevi_dati          import Invia
from .menu                       import GestioneMenu

class Main(RBase):
    """ Gestione
    """
    def doTask(self, *args, **kwargs):
        method = kwargs['method']
        if hasattr(self, method):
            return RBase.doTask(self, *args, **kwargs)
        else:
            classe = [m for m in self._classi if hasattr(m, method)][0]
            return RBase.doTask(classe(self), *args, **kwargs)

Main._classi = [GestioneInviaRicevi, GestioneListe, GestioneMenu, Invia, Ricevi]
Main.extend(RBaseExt)

