# -*- coding: utf-8 -*-
#
# File: menu.py
# Author: Marco Dalla Stella
# Date: 03/06/2010

from waonline.core.tabelle import *
from sqlalchemy.orm import backref

class Menu(Base):
    """
        Classe per la tabella dei menu
    """
    __tablename__ = "menu"
    __table_args__ = (UniqueConstraint('id', 'id_padre'), {})

    id = Column(Integer, primary_key=True, autoincrement=True)
    id_padre = Column(Integer, ForeignKey('menu.id'))
    nome = Column(String(50), nullable=False)
    azione_js = Column(String(255), nullable=True)
    autorizzazioni_richieste = Column(String(255), nullable=True)
    min_livello_utente = Column(Integer, default=0)
    sub_menu = relationship('Menu', remote_side='menu.c.id_padre', order_by='menu.c.id')

    @property
    def ha_sub_menu(self):
        return self.sub_menu != []

    def scorri_menu(self):
        yield self

        for figlio in self.sub_menu:
            if figlio.ha_sub_menu:
                for subs in figlio.scorri_menu():
                    yield subs
            else:
                yield figlio
