from waonline.core.tabelle import *

class Comune(Base):
    __tablename__ = "comuni"
    __table_args__ = (UniqueConstraint('codice'), {})
    id = Column(Integer, primary_key=True, autoincrement=True)
    codice = Column(String(5))
    descrizione = Column(String(50))
    provincia_id = Column(Integer, ForeignKey('province.id', onupdate='CASCADE', ondelete='SET NULL'))
    cap = Column(String(5))
    cod_fiscale = Column(String(4))
    comune_locFisc = Column(String(1))
    is_nazione = Column(Boolean)
    sigla_stato = Column(String(3))
    cod_uniemens = Column(String(3))
    is_ex_comune = Column(Boolean)
    cod_istat_com = Column(String(3))
    cod_istat_prov = Column(String(3))
    sede_inail = Column(String(5))
    # Relazioni one-to-one
    provincia_rel = relationship('Provincia', order_by='Provincia.id')


class Provincia(Base):
    __tablename__ = "province"
    __table_args__ = (UniqueConstraint('codice'), {})
    id = Column(Integer, primary_key=True, autoincrement=True)
    codice = Column(String(2))
    descrizione = Column(String(50))
    regione_id = Column(Integer, ForeignKey('regioni.id', onupdate='CASCADE', ondelete='SET NULL'))
    # Relazioni one-to-one
    regione_rel = relationship('Regione', order_by='Regione.id')


class Regione(Base):
    __tablename__ = "regioni"
    __table_args__ = (UniqueConstraint('codice'), {})
    id = Column(Integer, primary_key=True, autoincrement=True)
    codice = Column(String(2))
    descrizione = Column(String(50))

