from waonline.core.tabelle import *

class TabellaP(Base):
    __tablename__ = "tabelle_p"
    __table_args__ = (UniqueConstraint('formula', 'codice'), {})
    id = Column(Integer, primary_key=True, autoincrement=True)
    formula = Column(String(50))
    codice = Column(String(50))
    descrizione = Column(String(100))
    __mapper_args__ = {'polymorphic_on': formula}


class CausaCessazione(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "CAUSA_CESSAZIONE"}

class Collaborazione(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "COLLABORAZIONE"}

class DetrazioniArt13(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "DETRAZIONI_ART13"}

class DetrazioniFiscParent(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "DETRAZ_FISC_PARENT"}

class DichiarazSpettanza(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "DICHIARAZ_SPETTANZA"}

class EspoCedolino(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "ESPO_CEDOLINO"}

class InpsContratto(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "INPS_CONTRATTO"}

class Invalidita(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "INVALIDITA"}

class Parentela(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "PARENTELA"}

class PartTime(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "PART_TIME"}

class RetribuzioneMov(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "RETRIBUZIONE_MOV"}

class Sesso(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "SESSO"}

class SommDist(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "SOMM_DIST"}

class StatoCivile(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "STATO_CIVILE"}

class TipoContrDeterm(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "TIPO_CONTR_DETERM"}

class TitoloStudio(TabellaP):
    __mapper_args__ = {'polymorphic_identity': "TITOLO_STUDIO"}
