# -*- coding: utf-8 -*-
"""
Presenze
======================
"""
__fine_name__ = "__init__.py"
__author__ =    "Luca"
__email__ = "luca.z@essepaghe.it"
__web_site__ = "http://waonline.essepaghe.it"
__version__ =   "1.0.0"
__date__ =      "2012-04-30"
__app_name__ = "presenze"

from waonline.core.rbase                    import RBase
from waonline.apps.anagrafiche.ext          import RBaseExt

from .gest_presenze                         import GestionePresenze
from .stampa_presenze                       import StampaPresenze
from .stampa_presenze_riass                 import StampaPresenzeRiass


class Main(RBase):
    """ Gestione Presenze
    """
    #def _post_init_(self):
        #self._classi = [GestionePresenze, StampaPresenze, StampaPresenzeRiass]
        #for modulo in self._classi:
            #modulo.extend(RBaseExt)

    def doTask(self, *args, **kwargs):
        method = kwargs['method']
        if hasattr(self, method):
            return RBase.doTask(self, *args, **kwargs)
        else:
            classe = [m for m in self._classi if hasattr(m, method)][0]
            return RBase.doTask(classe(self), *args, **kwargs)

Main._classi = [GestionePresenze, StampaPresenze, StampaPresenzeRiass]
Main.extend(RBaseExt)
