#! /usr/bin/python
# coding: latin-1
"""
:File: admin_log.py
:Author: luca
:Version: 1.0.0
:Date: 26/01/2011

Modulo python per la tabella del log delle funzioni.
"""

from waonline.core.tabelle import Column, String, relationship, DateTime,\
        Integer, Base, ForeignKey
from sqlalchemy.types import Text
from waonline.core.users import NewUtente

class AdminLog(Base):
    """ Classe per il log delle funzioni """
    __tablename__ = "admin_log"
    id = Column(Integer, primary_key=True, autoincrement=True)
    user_id = Column(Integer, ForeignKey("new_utenti.id"))
    user = relationship(NewUtente, primaryjoin=user_id == NewUtente.id)
    ip = Column(String(15))
    cod_ditta = Column(String(7))
    periodo = Column(Integer)
    request = Column(String(255))
    data_inizio = Column(DateTime)
    data_fine = Column(DateTime)
    mtype = Column(String(30))
    task = Column(String(50))
    minput = Column(Text)
    output = Column(Text)
