#! /usr/bin/python
# -*- coding: latin-1 -*-
"""
"""
__fine_name__ = "ete_dumbobj.py"
__author__ =    "luca"
__version__ =   "1.0.0"
__date__ =      "2011-10-21"


import types

class EteDumbObj(dict):
    """ Stupida classe per accedere direttamente ai valori di un dizionario
    come fosse un oggetto.
    """
    def __init__(self, *args, **kwargs):
        dict.__init__(self, *args, **kwargs)

    def __getattr__(self, name):
        if name in self.__dict__:
            return self.__dict__[name]
        else:
            return self.get(name, None)

    def __setattr__(self, name, value):
        if name in self.__dict__:
            self.__dict__[name] = value
        else:
            self[name] = value

    def __delattr__(self, name):
        del self[name]

    def __dir__(self):
        return self.keys() + self.__dict__.keys()

    def __getstate__(self):
        return dict(self.items())


def dict2edo(d):
    #import ipdb; ipdb.set_trace()
    if isinstance(d, (list, tuple,)):
        for i in range(len(d)):
            d[i] = dict2edo(d[i])
    elif isinstance(d, dict):
        for k, v in d.items():
            d[k] = dict2edo(v)
    if isinstance(d, dict) and type(d) != EteDumbObj:
        d = EteDumbObj(d)
    return d
