"""
================
Sessions
================

.. autofunction:: require_lock

   decoratore che registra una funzione in modo da chiedere la sessione
   in modo bloccante

.. autofunction:: test_require_lock

"""

from waonline.core.sessions.db_manager import SessionManager


SESSION_LOCK_FUNCTIONS = []

def require_lock(func):
    """Mark the function to require sesion lock"""

    SESSION_LOCK_FUNCTIONS.append((func.__module__, func.func_name))
    return func


def test_require_lock(func):
    """Check if function needs locking the session while retrieving"""
    if not func:
        return False
    return (func.__module__, func.func_name) in SESSION_LOCK_FUNCTIONS
