#! /usr/bin/python
# -*- coding: utf-8 -*-
"""
================================================
Package per la gestione degli utenti di waonline
================================================

.. autoclass
   :members:
"""
__fine_name__ = "__init__.py"
__author__ =    "luca"
__version__ =   "1.0.0"
__date__ =      "2011-12-21"

from waonline.core.users.tabelle.new_utenti import NewUtente

class UsersManager(object):
    """ Gestione utenti """
    def __init__(self, db_manager):
        self.db_manager = db_manager
        self.nsdb = self.db_manager.get_sessiondb(None)

    #@property
    #def nsdb(self):
        #""" ritorna una nuova sessiondb usando db_manager """
        #return self.db_manager.get_sessiondb(None)

    def get_orphans(self, max=60, min=0):
        return NewUtente.get_orphans(max=max, min=min, sessiondb=self.nsdb)

    def user_exists(self, username):
        return NewUtente.user_exists(username, sessiondb=self.nsdb)

    def login(self, username, password):
        return NewUtente.login(username, password, sessiondb=self.nsdb)

    def get_by_id(self, uid):
        return NewUtente.get_by_id(uid, sessiondb=self.nsdb)

    def get_by_username(self, username):
        return NewUtente.get_by_username(username, sessiondb=self.nsdb)

    def get_by_property(self, property_name, value):
        return NewUtente.get_by_property(property_name, value,
                sessiondb=self.nsdb)

    def create_user(self, username, password, **kwa):
        return NewUtente.create_user(username, password,
                sessiondb=self.nsdb, **kwa)
