#! /usr/bin/python
# -*- coding: utf-8 -*-
"""
Decoratori aggiuntivi
"""
__fine_name__ = "decorators.py"
__author__ =    "luca"
__version__ =   "1.0.0"
__date__ =      "2012-01-11"


import functools
from sqlalchemy.orm import object_session

class SessionDbError(BaseException):
    """ Errore per la mancanza di sessiondb """
    def __init__(self, *args):
        self.args = args
        if len(self.args) == 0:
            self.args = ("La chaimata come classmethod esige il "\
                        "parametro sessiondb",)
    def __str__(self):
        if len(self.args) == 1:
            return str(self.args[0])
        else:
            return str(self.args)

    def __repr__(self):
        return "%s(*%s)" % (self.__class__.__name__, repr(self.args))

class userscombomethod(object):
    """ Permette di utilizzare lo stesso metodo sia per un'istanza che per
    la classe.
    (stackoverflow con appena una modifica)
    """
    def __init__(self, method):
        self.method = method

    def __get__(self, obj=None, objtype=None):
        @functools.wraps(self.method)
        def _wrapper(*args, **kwargs):
            #: Instance method
            if obj is not None:
                kwargs['sessiondb'] = object_session(obj)
                return self.method(obj, *args, **kwargs)
            #: Class method
            else:
                if not kwargs.get('sessiondb'):
                    raise SessionDbError
                return self.method(objtype, *args, **kwargs)
        return _wrapper
