# coding: latin-1
import traceback

from waonline.core import waologgin as wl

def custom_exception(*args, **kwargs):

    txt = traceback.format_exc()
    # stampa a vide lo stesso messaggio che manderesti via mail
    for line in txt.splitlines():
        wl.errore(line, dept=2)

def print_exc_plus(tb, _type, _value):
    """
    Print the usual traceback information, followed by a listing of all the
    local variables in each frame.
    """

    #tb = sys.exc_info()[2]
    stack = []

    while tb:
        stack.append((tb, tb.tb_frame))
        tb = tb.tb_next

    #traceback.print_exc() # questa non è 'value' ma la precedente eccezione!!!
    txt = ['']

    for tb, frame in stack:

        txt += ["File %s :%s in '%s'" % (frame.f_code.co_filename,
                                    frame.f_lineno,
                                    frame.f_code.co_name,
                                    )]
        filename, line_number, function_name, text = traceback.extract_stack(frame, 1)[0]
        txt += [" "*4 + text]
        for key, value in frame.f_locals.items():
            line =  "\t%20s = " % key
            #We have to be careful not to cause a new error in our error
            #printer! Calling str() on an unknown object could cause an
            #error we don't want.
            try:
                line = "%s%s" % (line, value)
            except Exception, e:
                print "EXC", line, e
                line += "<ERROR WHILE PRINTING VALUE>"
            txt += [line]

    txt += ["%s: %s" % (_type.__name__, _value)]
    return "\n".join(txt)


