#! /usr/bin/python
# coding: utf-8
"""
Client for http test
"""

import time
import urllib
import urllib2
import base64
import cookielib

def cparams(params):
    """ Converte i parametri
    :param params: a dict whose values will be urlencoded

    >>> cparams({'a' : 'luca', 'b' : ['sandro', 'anna']})
    a=luca&b=sandro&b=anna
    """
    data = []

    for k, vs in params.items():
        for v in (isinstance( vs, list) and vs or [vs]):
            data += [(k, v)]

    return urllib.urlencode(data)


class BaseHTTPClient(object):
    """Simple http client that supports cookie handling"""

    def __init__(self, base_url):

        self.base_url = base_url
#        self.opener = urllib2.build_opener()
 
        self.cookies = cookielib.CookieJar()
        self.opener = urllib2.build_opener(
            urllib2.HTTPCookieProcessor(self.cookies),
            urllib2.HTTPHandler(),
            urllib2.HTTPSHandler(),
            #urllib2.HTTPDefaultErrorHandler(),
        )
        self.opener.addheaders = [("User-agent", "Mozilla/5.0 (compatible)")]

        self.cookie = None
        self.last_response = None
        self.last_request = None

    def reset_cookie(self):
        "Reset any existent cookie"
        self.cookie = None

    def get(self, page_or_url):
        "GET a page"

        return self.req(page_or_url)


    def post(self, page_or_url, params):
        "POST a page"

        return self.req(page_or_url, params)

    def req(self, page, params=None):
        """issue the request. POST if params, else GET

        :param page: url or page to be compose with ``self.base_url``
        :param params: possible data to be urlencoded. If not None, POST is used
        """
        if params:
            data = cparams(params)
        else:
            data = None

        # prepare the URL
        if "http://" in page or "https://" in page:
            url = page
        else:
            url = self.base_url + page

        # execute the request preserving the cookie
        self.last_request = urllib2.Request(url, data)
        # if self.cookie:
        #     self.last_request.add_header('Set-Cookie', self.cookie)
        self.last_response =  self.opener.open(self.last_request)

        # cookie handling
        self.cookie = self.last_response.headers.getheader("Set-Cookie")
        if self.cookie:
            self.cookie_val = self.cookie[
                self.cookie.index("=")+1:self.cookie.index(";")]
        else:
            self.cookie_val = None

        return self.last_response

