function mostraSessioni() {
    pulisciSessioni = function () {
        isc.RPCManager.sendRequest({
            evalResult: false,
            showPrompt: false,
            httpMethod: "GET",
            callback: null,
            actionURL: '/admin/pulizia/'
        });
    };

    isc.DataSource.create({
        ID:'sessioniSource',
        dataFormat:'json',
        dataURL: "/admin/sessioni/"
    });

    isc.ListGrid.create({
        ID:"lstSessioni",
        dataSource: 'sessioniSource',
        autoFetchData: true,
        canEdit: false,
        canSort: true,
        canReorderFields: false,
        canGroupBy: true,
        showHeaderContextMenu: false,
        fields:[
            {name:'utente', title:'Codice', width:'5%'},
            {name:'descrizione', title:'Descrizione', width:'25%'},
            {name:'livello', title:'Livello', width:'10%'},
            {name:'indirizzo', title:'Indirizzo IP', width:'10%'},
            {name:'datalogin', title:'Data login', type:'date', width:'15%'},
            {name:'ultima_uri', title:'Ultima richiesta', width:'35%'}
        ],
        showFilterEditor: true,
        groupByField: 'indirizzo' 
    });

    wao.addSezione('Sessioni',lstSessioni);
    wao.mostraFiltri(false);
    wao.getBottoni([
        {title:"Pulisci sessioni", click:"pulisciSessioni()"},
        {title:"Aggiorna", click:"sessioniSource.fetchData(null, 'lstSessioni.setData(data)');"}
    ]);
}
function mostraLog(){
    mostraDettaglioLog = function(){
        isc.DataSource.create({
            ID:'logSource2',
            dataFormat:'json',
            dataURL:'/get?type=gest_adminlog&task=dettagli',
            fields:[
                {name:'log_id', title:'ID', primary_key:true, hidden: true, type:'integer'}
            ]
        });
        formatInput = function(value){
            var d = eval("d=" + value);
            var s = '<ul>';
            for (var prop in d){
                if (d.hasOwnProperty(prop)){
                    s+=sprintf("<li><b>%s</b> : %s</li>", prop,d[prop]);
                }
            }
            s+="</ul>";
            return s;
        };
        obj2ul = function(obj){
            var s = '';
            if (isc.is.Array(obj)){
                s+="<ul>";
                for (var i=0; i<obj.length;i++){
                    s+="<li>" + obj2ul(obj[i]) + "</li>"; 
                }
                s+="</ul>";
            }else if (isc.is.Object(obj)){
                s+="<ul>";
                for (var p in obj){
                    if (obj.hasOwnProperty(p)){
                        s+="<li><b>" + p + "</b> : " + obj2ul(obj[p]) +"</li>";
                    }
                }
                s+='</ul>';
            }else{
                s=obj;
            }
            return s;
        };
        formatOutput = function(value){
            var d = null;
            try{
                d = isc.XMLTools.toComponents(value);
                if (d.body){
                    if (d.body.parsererror){
                        try{
                            d = eval("d=" + value);
                        }catch(err2){
                            d = value;
                        }
                    }
                }
            }catch(err){
                try{
                    d = eval("d=" + value);
                }catch(err2){
                    d = value;
                }
            }
            return obj2ul(d);
        };
        log_id = lstLog.getSelectedRecord().log_id;
        if (log_id){
            isc.stdDialog.create({
                ID:'wndDettaglioLog',
                buttons:[isc.Dialog.CLOSE],
                width:600,
                items:[
                    isc.DetailViewer.create({
                        autoDraw:false,
                        recordsPerBlock:2,
                        ID:"frmDettaglioLog",
                        dataSource:"logSource2",
                        canSelectText:true,
                        fields:[
                            {name:'utente', title:'Utente'},
                            {name:'ip', title:'IP'},
                            {name:'cod_ditta', title:'Codice Ditta'},
                            {name:'periodo', title:'Periodo'},
                            {name:'data_inizio', title:'Data Inizio', type:'date'},
                            {name:'data_fine', title:'Data Fine', type:'date'},
                            {name:'mtype', title:'type'},
                            {name:'task', title:'task'},
                            {name:'request', title:'request'},
                            {name:'tempo', title:'tempo'},
                            {name:'minput', title:'input', type:'textarea', formatCellValue:formatInput},
                            {name:'output', title:'output', type:'textarea', formatCellValue:formatOutput}
                        ] 
                    })
                ]
            });
            frmDettaglioLog.fetchData({log_id:log_id});
        }
    };
    isc.DataSource.create({
        ID:'logSource',
        dataFormat:'json',
        dataURL:'/get?type=gest_adminlog&task=show_log',
        fields:[
            {name:'log_id', title:'ID', primary_key:true, hidden: true, type:'integer'}
        ]
    });
    isc.ListGrid.create({
        ID: 'lstLog',
        dataSource: 'logSource',
        autoFetchData: true,
        canEdit: false,
        canSort: true,
        canReorderFields: false,
        canGroupBy: true,
        showHeaderContextMenu: false,
        showFilterEditor: true,
        recordDoubleClick: mostraDettaglioLog,
        sortFieldNum: "data_inizio",
        sortDirection: "descending",
        fields:[
            {name:'utente', title:'Utente'},
            {name:'ip', title:'IP'},
            {name:'cod_ditta', title:'Codice Ditta'},
            {name:'periodo', title:'Periodo'},
            {name:'data_inizio', title:'Data Inizio', type:'date'},
            {name:'data_fine', title:'Data Fine', type:'date'},
            {name:'tempo', title:'tempo', type:'time'},
            {name:'mtype', title:'type'},
            {name:'task', title:'task'}
        ]
        //groupByField:'ip'
    });
    wao.addSezione('Logs',lstLog);
    wao.mostraFiltri(false);

    wao.getBottoni([
        {title:"Aggiorna", click:"logSource.fetchData(null, 'lstLog.setData(data)')"},
        {title:"Dettagli", click:"mostraDettaglioLog();"},
        {title:"Pulisci", click:function(){
            newSendData({get:{type:'gest_adminlog', task:'pulisci'},callback:"logSource.fetchData(null, 'lstLog.setData(data)');"});
        }}
    ]);
}
// vim:fdm=marker
