/**
 *  Modulo per le presenze al cubo
 */
function _refreshPresenze(id_dipendente){
    cuboSource.fetchData({id_dipte:id_dipendente},'cuboPresenza.setData(data);aggiornaDatiDettaglioPres('+id_dipendente+');');
}
function refreshPresenze(id_dipendente){
    if(wao.verificaSalvataggio("_refreshPresenze(" + id_dipendente + ");")){
        _refreshPresenze(id_dipendente);
    }
}
function __creaCuboPresenza(idati){
    listDipendenti.ritorna = true;
    isc.PresenzeCube.create({
        ID:'cuboPresenza',
        singolo: _cubeArgs.singolo,
        orientamento: _cubeArgs.orientamento,
        data: idati,
        canEdit: wao.isAperto()
        //showPrompt: true
    });
    _lastGriglia = cuboPresenza;
    var titolopres ='<b style="font-size:110%;">Presenze ' + wao.getPeriodo() +'<b/>';
    if (!wao.isAperto()){
        titolopres += ' (<span style="color:darkred">mese chiuso</span>)';
    }
    if (cuboPresenza.orientamento == 'orizzontale'){
        wao.addSezione(titolopres,
            isc.VLayout.create({members:[infoDipePresenze,cuboPresenza]}));
    }else{
        wao.addSezione(titolopres, 
                isc.HLayout.create({
                    ID:'cuboHlayout',
                    members:[isc.VLayout.create({showResizeBar: true,members:[infoDipePresenze,cuboPresenza]})]
                }));
    }
    wao.mostraFiltri(false);
    mostraDettaglioPresenze();
    infoTop.setContenuto();
    var bottoni = [];
    if (_cubeArgs.singolo){
        bottoni = bottoni.concat([
        {ID:'btnPrimo', title:"<<", width:40, click:function(){
                refreshPresenze(listDipendenti.rscroll.first().id);
            }
        },
        {ID:'btnPrec', title:"<", width:40, click:function(){
                refreshPresenze(listDipendenti.rscroll.prev().id);
            }
        },
        {ID:'btnPros', title:">", width:40, click:function(){
               refreshPresenze(listDipendenti.rscroll.next().id);
            }
        },
        {ID:'btnUltimo', title:">>", width:40, click:function(){
               refreshPresenze(listDipendenti.rscroll.last().id);
            }
        }]);
        if (_cubeArgs.orientamento == 'orizzontale'){
            bottoni.push({title: "Verticale", click: "creaCuboPresenze({singolo:true,orientamento:'verticale'});" });
        }else{
            bottoni.push({title: "Orizzontale", click: "creaCuboPresenze({singolo:true,orientamento:'orizzontale'});" });
        }
    }
    bottoni = bottoni.concat([
        {ID:"btnAggiornaPres", title: "Aggiorna", click: "salvaCalendario(creaAnagrafichePresenze)"}, 
        {title: "Verifica Calendario", click: "verificaCalendario();"}, 
        {title: "Riassuntivo", click: "mostraRiassuntoDipe(true);"},
        {ID:"btnEsciPres", title: "Esci", click: function(){
                if(wao.verificaSalvataggio("creaAnagrafichePresenze();")){
                    creaAnagrafichePresenze();
                }
            },
            setDisabled: function(){}
        }
    ]);
    wao.getBottoni(bottoni);
    if (cuboPresenza.singolo && cuboPresenza.orientamento=='orizzontale'){
        rightSideLayout.expandSection("dettPresenze");
    }
    wao.disabilitaScorrimento();
    btnAggiornaPres.setDisabled(!wao.isAperto());
    wao.addTimeCallback("hasDomicilio",function(){try{if (!wao.hasDomicilio()){tabDomicilioPres.hide();}}catch(err){return false;} return true;}, 10, 1);
}
function creaCuboPresenze(args) {
    if (!wao.getPeriodo()){
        if (confirm("Nessun mese aperto. Aprirne uno ?")){
            creaApriMese();
        }
        return;
    }
    wao.removeTimeCallback('conteggio');
    args.orientamento = args.orientamento || 'orizzontale';
    args.singolo = args.singolo || false;
    _cubeArgs = args;
        isc.HTMLPane.create({
        ID:'infoDipePresenze',
        overflow:"visible",
        styleName:"infoDipePresenze",
        height: 40,
        padding:0,
        autoDraw:false,
        setContenuto: function(dipendente){
            this.dipendente = dipendente;
            this.setContentsURL("/html/infoDipePresenze.html");
        },
        transformHTML: function (html){
            var data = null;
            if(typeof(this.dipendente.data_ass)!=="string"){
                try{
                    data = this.dipendente.data_ass.toEuropeanShortDate();
                }catch(errst){
                    data = wao.intToDataStr(this.dipendente.data_ass);
                }
            }else{
                data = wao.intToDataStr(this.dipendente.data_ass);
            }
            return sprintf( html, this.dipendente.codice || "", this.dipendente.nominativo || "", data || "", 
                this.dipendente.qualifica || "", this.dipendente.livello || "", this.dipendente.centro_costo || "");
        }
    });
    isc.DataSource.create({
        ID: "cuboSource",
        dataFormat: "json",
        method: 'POST',
        showPrompt: true,
        dataProtocol: "postParams",
        //dataURL: '/app/presenze/carica_calendario'
        dataURL: _gApp('presenze', 'carica_calendario')
    });
    // Carico i dati e aggiungo la sezione dei dettagli
    var id_dipte = 0;
    if (_cubeArgs.singolo){
        id_dipte = listDipendenti.rscroll.record().id;
    }else{
        id_dipte = listDipendenti.getIdList();
    }
    if ((typeof (cuboPresenza) != 'undefined') && cuboPresenza){
        if (cuboPresenza){
            cuboPresenza.saveAllEdits();
            __creaCuboPresenza(cuboPresenza.data);
        }
    }else{
        newSendData({
            url:'app/presenze/carica_calendario',
            params:{id_dipte: id_dipte},
            callback:function(data){
                var idati = _fixCuboData(data);
                if(idati){
                    __creaCuboPresenza(idati);
                }
            }
        });
    }
}

