/**
 *  modulo di definizione per le presenze
 */
function _fixCuboData(pidati){
    var idati = null;
    if (isA.Array(pidati)){
        idati = pidati;
    }else{
        idati=pidati.data;
    }
    if (idati){
        try{
            var ot = idati.findAll("rows","C0");
            var ol = idati.findAll("rows","C1");
            //var o6 = idati.findAll("rows","C6");
            for (var i = 0;i < ot.length;i++){
                ot[i].customStyle = "cubeCellOT";
                ot[i].baseStyle = "cubeCellOT";
                ol[i].enabled = false;
                //o6[i].baseStyle = "cubeCellCC";
                //o6[i].customStyle = "cubeCellCC";
            }
        }catch(errore){
            return null;
        }
    }
    return idati;
}
var __efd = isc.clone(isc.A.editFormDefaults);
__efd.fieldIdProperty='id';
__efd.selectOnFocus = false;

isc.defineClass("PresenzeCube", "CubeGrid").addProperties({
    width:"100%",
    height:"90%",
    canEdit:true,
    editByCell:true,
    autoDraw:false,
    autoFethData: false,
    editFormDefaults:__efd,
    selectOnFocus: false,
    fieldIdProperty:'id',
    valueProperty: "value",
    cellIdProperty: "cellID",
    showFacetValueContextMenus: true,
	showFacetContextMenus:		true,
	showCellContextMenus:		true,
	canCollapseFacets:false,
	canMinimizeFacets:false,
	autoSelectValues:"both",	// both, cols, row, none
	rowHeaderGridMode:true,
	canMoveFacets:true,
    canFocus: true,
    showAllColumns: true,
    characterCasing: "upper",
    alternateRecordStyles: false,
    showAllRecords: false,
    wrapCells: false,
    hoverWidth: 200,
    hoverHeight: 20,
    selectionType: "single",
    actRow: 0,
    canGroupBy: false,
    autoSaveEdits: false,
    cellHeight: 24,
    fixedRecordHeights: 24,
    validateByCell: true,
    emptyMessage: '',
    colonne: null,
    saveLocally: true,
    hideEmptyFacetValues: false,
    singolo:false,
    orientamento:'orizzontale',
    autoFitMaxRecords: null,
    baseStyle:'cubeCellPR',
    autoSizeHeaders:true,
    defaultFacetWidth:72,
    _hasChages:false,
    setData: function(newData){
        if(newData){
            if(isc.isA.Array(newData)){
                newData = _fixCuboData(newData);
            }else if(isc.isA.Array(newData.data)){
                newData.data = _fixCuboData(newData.data);
            }
            arguments[0] = newData;
        }
        this.Super('setData',arguments);
    },
    showInlineEditor: function (){
        this.Super('showInlineEditor',arguments);
        if (this.$4r.getField(0).focus){
            this.$4r.getField(0).focus();
        }
   },
    initWidget: function(){
        this._setDaysFields();
        this.Super("initWidget", arguments);
    },
    bodyKeyPress:function (evento){
        var cella = this.getSelectedCells()[0];
        if (evento.nativeKeyCode==13){
            if (wao.isAperto()){
                c = this.getCellCoordinates(cella);
                this.startEditing(c[0],c[1],false);
            }
        }else if(evento.keyName=='Delete'){
            if (wao.isAperto() && cella.value){
                this.verificaCella(cella, '', this.verificaCallback);
            }
        }

        if (cella.id_dipe) {
            aggiornaDatiDettaglioPres(cella.id_dipe);
        }
        return this.Super('bodyKeyPress',arguments);
    },
    editorKeyPress: function(cella,tasto,altro){
        if (tasto == 'f8' || tasto == 'f6'){
            //if (cella.record.rows == 'C6'){
                //getListaCausali(cella,_lCentriCosto);
            //}else{
            getListaCausali(cella,_lCausali);
            //}
            return false;
        } else {
            this.Super('editorKeyPress',arguments);
            return true;
        }
    },
    presTextDoubleClick: function(cella, record, value){
        if (cella.grid.orientamento == 'verticale'){
            if (cella.colNum === 0 ) {
                mostraCentriCosto(record);
            }else{
                getListaCausali(cella,_lCausali);
            }
        }else{
            //if (record.rows == "C6") {
                //mostraCentriCosto(record);
            //}else{
            getListaCausali(cella,_lCausali);
            //}
        }
    },
    _setDaysFields: function(){
        var lrowsvals = [
            {id: "C0", title: "ore teoriche", baseStyle:'cubeCellOT'},
            {id: "C1", title: "ore lavorate"},
            {id: "C2", title: " "},
            {id: "C3", title: " "},
            {id: "C4", title: " "},
            {id: "C5", title: " "},
            {id: "C6", title: " "} //title: "Centri di Costo", baseStyle:'cubeCellCC'}
        ];
        if (!this.singolo){
            this.rowFacets=["nome","rows"];
            this.columnFacets=["cols"];
        }else{
            if (this.orientamento=='orizzontale'){
                this.rowFacets=["rows"];
                this.columnFacets=["cols"];
            }else{
                //lrowsvals = [
                    //{id: "C6", title: "Centri di Costo", baseStyle:'cubeCellCC'},
                    //{id: "C0", title: "ore teoriche", baseStyle:'cubeCellOT'},
                    //{id: "C1", title: "ore lavorate"},
                    //{id: "C2", title: " "},
                    //{id: "C3", title: " "},
                    //{id: "C4", title: " "},
                    //{id: "C5", title: " "}
                //];
                this.rowFacets=["cols"];
                this.columnFacets=["rows"];
            }
        }
        this.facets=[
            //{id:'id_dipte',name:'id_dipte',title:'Dipendente'},
            {id:'nome',name:'nome',title:'Dipendente',width:150,align:'left'},
            {id:'rows',title:'Righe',width:1, values: lrowsvals},
            {id:'cols', name:'cols', title:'Giorni',width:72}
        ];
    },
    editorExit: function (editCompletionEvent, record, newValue, rowNum, colNum) {
        if (wao.isDef(newValue) && (record.value != newValue)){
            this.verificaCella(record, newValue, this.verificaCallback);
            this._hasChages = true;
        }
        var valore =  this.Super('editorExit',arguments);
        return valore;
    },
    verificaCella: function(record, valore, callback){
        var nrecord = {};
        nrecord.giorno = parseInt(record.cols.substr(3),10);
        nrecord.causale = parseInt(record.rows.substr(1),10);
        nrecord.valore = valore;
        nrecord.id_dipte = record.id_dipe;
        if (nrecord.causale === 0){
            if (wao.isNumber(valore)){
                nrecord.valore = record.value.substr(0,2) + valore ;
            }
        }
        newSendData({
            //blocking: true,
            url: 'app/presenze/gestione_giorno',
            params:nrecord,
            callback:callback,
            showPrompt:false,
            promptStyle:"cursor"
        });
    },
    verificaCallback: function(data){
        try{
            if(data){
                var cellaAttuale= cuboPresenza.getSelectedCells()[0];
                for (var i = 0 ; i < data.length;i++){
                    var cdata = cuboPresenza.data.findAll('id_dipe',
                        data[i].id_dipe).findAll('rows', 
                        data[i].rows).findAll('cols', data[i].cols)[0];
                    cuboPresenza.deselectAll();
                    cuboPresenza.selectCell(cdata);
                    var cella = cuboPresenza.getSelectedCells()[0];
                    var coords = cuboPresenza.getCellCoordinates(data[i]);
                    cuboPresenza.setEditValues(coords,data[i]);
                    if (typeof(data[i].enabled) == 'undefined'){
                        cella.enabled=true;
                    }else{
                        cella.enabled=data[i].enabled;
                    }
                    //cuboPresenza.refreshCell(coords[0],coords[1]);
                    cuboPresenza.refreshCellStyle(coords[0], coords[1]);
                }
                //cuboPresenza.redraw();
                cuboPresenza.deselectAll();
                cuboPresenza.saveAllEdits();
                cuboPresenza._hasChages = true;
                cuboPresenza.selectCell(wao.cellaAttuale);
                cuboPresenza.startEditing(wao.cellaAttuale.$24t, wao.cellaAttuale.$24.u);
            }
        }catch(err){}
    },
    rowClick: function(record, recordNum, fieldNum) {
        this.actRow = recordNum;
        aggiornaDatiDettaglioPres(record.id_dipe);
    },
    hasChanges: function(){
        return (this._hasChages || this.Super("hasChanges",arguments));
    },
    getCellStyle: function (record, rowNum, colNum){
        var style = this.Super("getCellStyle",arguments);
        if (this.orientamento == 'orizzontale'){
            if (record.rows=='C0') {
                style="cubeCellOT";
            }
            //if (record.rows=='C6'){
                //style="cubeCellCC";
            //}
        }else{
            //if (colNum===0){
                //style="cubeCellCC";
            //}
            if (colNum===0){
                style="cubeCellOT";
            }
        }
        return style;
    },
    getEditorType: function(field, values) {
        if (values.rows=='C0') {
            return "PresComboBoxItem";
        }
        return "PresTextItem";
    },
    getEditorValueMap: function (field, values){
        return ['OT','FG'];
    },
    setEditaCella: function (id_dipte,nCausale,nGiorno) {
        var cella = null;
        var rows = null;
        var cols = null;
        try{
            rows = "C"+nCausale;
            cols = this.getField(nGiorno - 1).id;
            cella = this.data.findAll('id_dipe',id_dipte).findAll('cols',cols).findAll('rows',rows)[0];
        }catch(errore){}
        if (wao.isDefNotNull(cella)){
            var coords = this.getCellCoordinates(cella);
            this.startEditing(coords[0],coords[1]);
        }
    }
});
function mostraCentriCosto(){
    isc.DataSource.create({
        ID: "srcCCPres",
        fields: [
            {name: "centro_costo", title: "Centro di Costo"},
            {name: "causale_ore", title: "Causale Ore"}
        ]
    });
    isc.ListGrid.create({
        ID: "lstCCPres",
        dataSource: "srcCCPres",
        emptyMessage: "",
        canEdit: true,
        data:[
            {centro_costo: 'ma', causale_ore: 'fe 05'}
        ],
        getEditorType: function(field, values){
            if (field.name == 'causale_ore') {
                return "PresTextItem";
            }else{
                return this.Super('getEditorType', arguments);
            }
        }
    });
    isc.stdDialog.create({
        ID: "wndCCPres",
        width: 300,
        height: 400,
        autoSize: false,
        items:[lstCCPres],
        buttons: [isc.Dialog.CONFIRM, isc.Dialog.CANCEL]
    });


}
