function mostraRicevi() {
    wao._lastNode = null;
    isc.DataSource.create({
        ID: "fileSource",
        dataFormat: "xml",
        autoFetchData: false,
        dataURL: _gApp('gestione', 'leggiListaFile'),
        recordXPath: "/files/file"
    });
    isc.ListGrid.create({
        ID: "listFiles",
        dataSource: "fileSource",
        alternateRecordStyles: true,
        showAllRecords: true,
        wrapCells: false,
        fixedRecordHeights: false,
        canDragRecordsOut: false,
        canReorderRecords: false,
        canSort: true,
        canAcceptDroppedRecords: false,
        hoverWidth: 200,
        hoverHeight: 20,
        selectionType: "single",
        autoFitData: "horizontal",
        width: 595,
        height: 200,
        emptyMessage: "Nessun file in ricezione",
        fields: [
            { name: 'nome', title: 'nome' },
            { name: 'data', title: 'data' },
            { name: 'ora', title: 'ora' }
        ],
        recordClick: function(viewer, record, recordNum, field, fieldNum, value, rawValue) {
            htmlFileInfo.setContentsURL("/app/gestione/getFileInfo", {
                nome_file: record.nome, 
                cartella: ncartella.getValue()
            });
        }

    });
    if (["81","82"].contains(document.location.host.slice(-2))){
        isc.DynamicForm.create({
            ID: "uploadForm",
            numCols: 4,
            encoding: "multipart",
            action: _gApp("gestione","upLoadFile"),
            fields: [
                        {ID: "fupload", name: "file", type: "upload" },
                        {ID: "ncartella", name: "cartella", type: "select",
                            valueMap: ['ricevi', 'invia'],
                            defaultToFirstOption: true,
                            icons: [
                                    {src: "/img/arrow_up.png", click: "uploadForm.submitForm();"},
                                    { src: "/img/move_task_down.png", click: "wndFile.downloadFile();" }
                            ],
                            changed: "uploadForm.ricarica()"
                        }
                    ],
            ricarica: function() {
                fileSource.fetchData({
                    cartella: ncartella.getValue()
                },
                "listFiles.setData(data)");
            }
        });
    }else{
        uploadForm = null;
        ncartella ={getValue: function(){return 'ricevi';}};
    }
    isc.stdDialog.create({
        ID: "wndFile",
        title: "Ricevi File",
        items: [listFiles, 
                isc.HTMLPane.create({
                    ID: "htmlFileInfo",
                    //top:40, width:280,
                    width: 595,
                    height: 180,
                    styleName: "infoFile",
                    contents: ''
                }), 
                uploadForm
        ],
        buttons: [Dialog.CONFIRM, {
            title: "Elimina",
            width: 75,
            click: function() {
                this.topElement.eliminaFile();
            }
        },
        Dialog.CLOSE],
        mrefresh: function(){
            findCodice.fetchData();
            wao.refreshCallback();
            fileSource.fetchData(null, "listFiles.setData(data)");
            htmlFileInfo.setContents('');
        },
        confirm: function(app, method) {
            app = app || 'gestione';
            method = method || 'ricevi';
            var nome_file = listFiles.getSelectedRecord().nome;
            var oparams = {nome_file: nome_file}; 

            if (method == 'eliminaFile'){
                oparams.cartella =ncartella.getValue(); 
            }
            newSendData({
                url: 'app/' + app + '/' + method,
                params: oparams,
                callback:function(data){
                    wndFile.mrefresh();
                    infoMovi.setContentsURL('/app/gestione/getFilesInfo');
                }
            });
            return false;
        },
        eliminaFile: function() {
            this.confirm('gestione','eliminaFile');
        },
        downloadFile: function() {
            var record = listFiles.getSelectedRecord();
            if (record){
                var nome_file = record.nome;
                window.open(_gApp("gestione", "downloadFile",{
                    nome_file: nome_file,
                    cartella: ncartella.getValue()
                }), "download");
                uploadForm.ricarica();
            }
        }
    });
    fileSource.fetchData(null, "listFiles.setData(data)");
    wndFile.show();
}

function mostraInvia() {
    wao._lastNode = null;
    //periodiSource.dataURL = _gApp("anagrafiche", "periodi_ditta");
    isc.stdDialog.create({
        ID: 'wndInvia',
        height: 200,
        width: 530,
        autoSize: true,
        canDragResize: false,
        buttons: [{
            title: "Invia",
            click: function() {
                this.topElement.invia();
            }
        },
        Dialog.CLOSE],
        items: [isc.DynamicForm.create({
            top: 10,
            cellPadding: 4,
            numCols: 4,
            height: 100,
            ID: "inviaPeriodiForm",
            //target:"_blank",
            action: "/app/gestione/invioGenerale",
            //canSubmit: true,
            encoding :"multipart",
            fields: [{
                name: "cod_ditta",
                title: 'Ditta',
                type: 'select',
                width: 250,
                optionDataSource: "ditteSource",
                pickListWidth: 250,
                displayField: 'descrizione',
                defaultToFirstOption: true,
                colSpan: 4,
                changed: "form.cambiaPeriodo();"
            },
            {
                name: "codice",
                type: "hidden"
            },
            //{
                //name: 'invia_ana_dipe',
                //title: 'Invia anagrafiche dipendente',
                //type: 'checkbox',
                //colSpan: 4
            //},
            {
                name: 'somm_dist',
                title: 'Invia anagrafiche somministrati/distaccati',
                type: 'checkbox',
                valueMap:[false,true],
                defaultValue:false,
                colSpan: 4
            },
            {
                name: 'presenze',
                title: 'Invia Presenze',
                type: 'checkbox',
                defaultValue:false,
                valueMap:[false,true],
                change: "form.getField('periodo').setDisabled(!value);"
            },
            {
                name: "periodo",
                title: 'Periodo',
                type: "select",
                width: 100,
                pickListWidth: 100,
                displayField: 'periodo',
                defaultToFirstOption: true,
                fetchMissingValues: true,
                autoDraw: false,
                autoFetchData: false,
                optionDataSource: "periodiSource",
                getPickListFilterCriteria:function(){
                    return {cod_ditta:this.cod, stato:"C", inviato:false};
                },
                disabled: true
            },
            {
                name: 'invia_mess',
                title: 'Invia Messaggio',
                type: 'checkbox',
                valueMap:[false,true],
                defaultValue:false,
                colSpan: 4,
                change: "form.getField('note').setDisabled(!value)"
            },
            {
                name: 'note',
                title: ' ',
                type: "textArea",
                TitleOrientation: "right",
                width: 500,
                height: 120,
                colSpan: 4,
                disabled: true
            }
            ],
            cambiaPeriodo: function(){
                var p = this.getField('periodo');
                p.cod = this.getField('cod_ditta').getValue();
                this.getField('cod_ditta').setValue(p.cod);
                p.fetchData();
                p.setTop();
            }
        })],
        invia: function() {
            //inviaPeriodiForm.submitForm();
            newSendData({
                url: 'app/gestione/invioGenerale',
                params:inviaPeriodiForm.getValues(),
                callback: function(data){
                    if (!_lastResponse.hasErrors){
                        wao.aggiornaPeriodo();
                        try{
                            inviaPeriodiForm.cambiaPeriodo();
                            lstPeriodi.setData([]);
                            lstPeriodi.fetchData({cod_ditta:wao.getCodDitta()});
                        }catch(era){}
                    }
                }
            });
        }
    });
    inviaPeriodiForm.cambiaPeriodo();
       
}
function esportaPresenze() {
    isc.stdDialog.create({
        title: "Esportazione Mese",
        confirm: function() {
            newSendData({
                url: 'gestione/invia',
                params: this.vLout.members[0].getValues()
            });
            return true;
        },
        items: [isc.DynamicForm.create({
            top: 10,
            cellPadding: 4,
            numCols: 8,
            height: 100,
            fields: [{
                name: "cod_ditta",
                title: 'Ditta',
                type: 'select',
                width: 250,
                optionDataSource: "ditteSource",
                pickListWidth: 250,
                displayField: 'descrizione',
                defaultToFirstOption: true
            },
            {
                name: "periodo",
                title: 'Periodo',
                type: "select",
                width: 250,
                pickListWidth: 250,
                displayField: 'periodo',
                defaultToFirstOption: true,
                fetchMissingValues: true,
                autoDraw: false,
                autoFetchData: true,
                optionDataSource: "periodiSource"
            }]
        })]
    });
}
