isc.DataSource.create({
    ID:"menuSource",
    dataFormat:"xml",
    dataURL:"/app/gestione/menu",
    recordXPath:"/menus/menu",
    autoFetchData: false,
    fields:[
        {name:'id',title:'ID', primaryKey:true, required:true, type:"integer"},
        {name:'genitore_id',title:'ID Genitore', required:true, foreignKey:"menuSource.id", type:"integer"},
        {name:'nome', title:"Nome"},
        {name:'azione', title:"Azione"}
    ]
});

isc.DataSource.create({
    ID:"ditteSource",
    dataFormat:"json",
    dataURL: "/app/anagrafiche/lista_ditte",
    fields:[
        {name:"cod_ditta",title:'Codice'},
        {name:"descrizione",title:'Descrizione'}
    ],
    autoFetchData:false
});
isc.DataSource.create({
    ID:"periodiSource",
    dataFormat:"json",
    dataURL:"/app/anagrafiche/periodi_ditta",
    blocking: true,
    fields:[
        {name:'periodo',title:"Periodo", type:"text"},
        {name:'stato',title:"Stato",type:"text"},
        {name:'inviato',title:"Inviato",type:"text"},
        {name:'display',title:"Periodo",type:"text"}
    ],
    autoFetchData: false
});
// User Interface
// ---------------------------------------------------------------------

// Menu principale
isc.TreeGrid.create({
    ID:"menuTree",
    dataSource:"menuSource",
    //position: "relative",
    autoFetchData: false,
    nodeClick: "wao.getAzione(node)",
    showHeader:false,
    leaveScrollbarGap:false,
    animateFolders:true,
    canAcceptDroppedRecords:false,
    canReparentNodes:false,
    selectionType:"single",
    height:"*",
    animateRowsMaxTime:750,
    idField : "id",
    parentIdField: "genitore_id",
    loadDataOnDemand: false,
    fields:[{name:'nome'}]
});

// Info
isc.HTMLPane.create({
    ID:"infoRice",
    //contentsURL:"/app/gestione/getRicInfo",
    overflow:"auto",
    styleName:"infoFile",
    height: 100,
    canCollapse: false,
    padding:5
});


// Info file da ricevere
isc.HTMLPane.create({
    ID:"infoMovi",
    //contentsURL:"/app/gestione/getFilesInfo",
    overflow:"auto",
    styleName:"infoFile",
    padding:5
});


isc.HTMLPane.create({
    ID:"infoFront",
    contentsURL:"/html/front.html",
    overflow:"auto",
    styleName:"defaultBorder",
    padding:5
});
   isc.SearchForm.create({
    ID:"findForm",
    autoFetchData: false,
    top:10,
    cellPadding:4,
    numCols:8,
    fields:[{
            ID:'findCodice',
            name:"cod_ditta",
            title:'Ditta',
            type:'select',
            width:250,
            //optionDataSource:"ditteSource",
            autoFetchData: false,
            pickListWidth:250,
            displayField :'descrizione',
            defaultToFirstOption: true,
            fetchMissingValues:false,
            changed:"wao.getUserPref();wao.aggiornaPeriodo();findForm.findItems();caricaCausaliEventiVoci();",
            dataArrived: function (startRow, endRow){
                findForm.findItems();
                infoTop.setContenuto();
            }
        },
        {
            ID: "findNominativo",
            name:"nominativo",
            title:'Filtro',
            icons: [{
                src: "/img/demoApp/icon_view.png",
                click: "findForm.findItems();"
            }],
            keyPress: function (item, form, keyName, characterValue) {
                if (keyName == "Enter"){
                    findForm.findItems();
                }
            }
        },
        {
            ID:'listPeriodi',
            name:"periodo",
            title:'Periodo',
            type:"select",
            width:250,
            //optionDataSource:"periodiSource",
            pickListWidth:250,
            displayField :'display',
            valueField: 'periodo',
            defaultToFirstOption: true,
            fetchMissingValues :false,
            autoDraw: false,
            autoFetchData:false,
            pickListFields: [
                { name:"periodo" },
                { name:"stato" },
                { name:"inviato" }
            ],
            changed:"findForm.findItems();caricaCausaliEventiVoci();",
            dataArrived: function (startRow, endRow, data){
                caricaCausaliEventiVoci();
            }
        },
        {
            ID:"escludi_cessati",
            name:"escludi_cessati",
            editorType:"checkbox", 
            title:"Escludi cessati",
            defaultValue:true,
            primaryKey:true,
            changed:"findForm.findItems();"
        }
    ],
    caricaPeriodo: function(){
        wao.aggiornaPeriodo();
        caricaCausaliEventiVoci();
    },
    findItems : function () {
        var findValues = this.getValues();
        if (listPeriodi.getValue()===null){
            this.caricaPeriodo();
        }
        try{
            dipeSource.fetchData(findValues,"listDipendenti.setData(data);listDipendenti.rscroll.update();infoTop.setContenuto();");
        } catch(errore){}
    }
});

isc.Toolbar.create({
    ID:"toolBottoni",
    //buttonConstructor:"IButton",
    buttonDefaults:{
        autoFit: false, 
        height: 22,
        overflow:'visible',
        width:2,
        hiliteAccessKey: true,
        //labelLengthPad:8,
        titleStyle:'styleBottoni'
    },
    width:"100%",
    height: 30,
    align:'right',
    layoutMargin:3,
    autoDraw:false,
    membersMargin: 6
});

isc.SectionStack.create({
    ID:"rightSideLayout",
    visibilityMode:"multiple",
    animateSections:false,
    autoDraw: false,
    sections:[
        {ID:'filtri', title:"Filtri", autoShow:true, items:[
            isc.HStack.create({
                ID:"findPane",
                height:30,
                styleName:"defaultBorder",
                members:[findForm],
                hidden: true
            }) 
        //infoFront
        ]}
    ]
});
isc.VLayout.create({ 
ID:"totalePagina",
width: "100%",
height: "100%",
layoutMargin:2,
autoDraw:false,
animateMembers:false,
members:[ 
    isc.HTMLPane.create({
        ID:"infoTop",
        height:62,
        overflow:"hidden",
        styleName:"InfoTop",
        contents:'<div class="infoTop"><span class="nomePrg">WebAzienda</span><span id="infoAzienda" class="infoAzienda"></span><span id="infoMsg" class="infoMsg"><a href="javascript:wao.hideInfoMsg();"><img src="/SKIN/actions/help.png"/></a><span id="infoMsgText"></span> </span></div><br>',
        setContenuto: function(){
            var info = ''; 
            if (wao.up.livello < 60){
                info = findCodice.getDisplayValue();
            }else{
                if (wao.up.username && wao.up.descrizione){
                    info = wao.up.username + " - " + wao.up.descrizione;
                }else{
                    info = null;
                }
            }
            if (info){
                var infoAzienda = document.getElementById('infoAzienda');
                if (infoAzienda){
                    infoAzienda.innerHTML = info;
                }
                return true;
            }else{
                return false;
            }
        }
    }),
    isc.HLayout.create({
        ID:"pageLayout",
        animateMembers:false,
        width:"100%",
        height:"100%",
        layoutMargin:2,
        autoDraw: false,
        members:[
            isc.SectionStack.create({
                ID:"leftSideLayout",
                width:200,
                showResizeBar:true,
                visibilityMode:"multiple",
                animateMembers:false,
                animateSections:true,
                sections:[
                    {title:"Menu", autoShow:true, items:[menuTree]},
                    {title:"Informazioni", autoShow:true, items:[infoRice]},
                    {title:"Dati inviati dallo studio", autoShow:true, items:[infoMovi]}
                ]
            }),
            infoFront
        ]
    })
]
}); 
isc.HTMLPane.create({
    ID:"cmdDiv",
    position:"relative",
    top: 63,
    height: 22,
    minWidth: 330,
    width: 330,
    textAlign: 'right',
    autoDraw: false,
    autoShow: false,
    styleName:"elementCmdDiv",
    contents:'<div id="cmdDiv" class="cmdDiv"> <a id="wahelp" href="/html/help/index.html" target="WebAzienda Help"><img src="/img/icons/help.png"/>Aiuto</a> <a href="javascript:mostraFormSegnalazioni();"><img src="/img/icons/edit.png">Invia segnalazione</a> <a href="javascript:wao.eseguiLogout();"><img src="/img/icons/shutdown.png">Esci</a></div>'
});
menuTree.fetchData();
listPeriodi.hide();
isc.Page.setEvent("load", "totalePagina.draw();wao.load();");
