/**
 *	Modulo base
 */
// Crea listDipendenti {{{
function getListaDipe(quale){

    if (typeof(listDipendenti)!='undefined'){
        if (listDipendenti){
            if (listDipendenti.tipo == quale){
                listDipendenti.markForRedraw();
                listDipendenti.visible = true;
                return listDipendenti;
            }
            //listDipendenti.destroy();
            //delete listDipendenti;
        }
    }
    if (quale == 'anagrafiche'){
        isc.DipendentiGrid.create({
            selectionType: 'single',
            selectionAppearance: "rowstyle",
            recordDoubleClick: function recordDoubleClick (viewer, record, recordNum, field, fieldNum, value, rawValue){
                dipeSource.defaultParams.stato = 'visualizza';
                creaDettagliAnagrafica(this.rscroll.record().id);
	        },
            tipo: 'anagrafiche'
        });
    } else {
        isc.DipendentiGrid.create({
            selectionAppearance: "checkbox",
            recordDoubleClick: "creaCuboPresenze({singolo:true,orientamento:wao.up.imp.orientamento});",
            tipo: 'presenze'
        });
    }
    return listDipendenti;
}
// }}}
// Crea DataSource Dipendenti {{{
function getDipeSource(fields){
    if (typeof(dipeSource)=='undefined'){
        isc.DataSource.create({
            ID: "dipeSource",
            dataFormat: "json",
            dataURL: "/app/anagrafiche/gestione_anagrafiche",
            //recordXPath: "/dipendenti/dipendente",
            promptStyle:'dialog',
            showPrompt: true,
            autoFetchData: false,
            method: "POST",
            tipo: null,
            defaultParams: {
                stato: 'lista',
                archivio: 'p',
                tipo: 'a'
            },
            fields: [
                { name: 'id', title: "ID", hidden: true, primaryKey:true},
                { name: 'codice', title: "Codice" },
                //{ name: 'tipo', title:"Tipo" },
                { name: 'matricola', title: "ID" },
                { name: 'nominativo', title: "Nominativo" },
                { name: 'data_ass', title: "Data Assunzione", type:'date', formatCellValue:"wao.intToDataStr(value);"},
                { name: 'data_cess', title: "Data Cessazione", type:'date', formatCellValue:"wao.intToDataStr(value);" },
                //{ name: 'data_ingresso', title: "Data Ingresso" },
                //{ name: 'data_uscita', title: "Data Uscita" },
                { name: 'centro_costo', title: "Centro Costo" },
                { name: 'qualifica', title: "Qualifica" },
                { name: 'livello', title: "Livello" },
                { name: 'inail', title: "Inail" }
            ],
            fetchData: function(){
                if(listDipendenti != 'undefined'){
                    this.tipo = listDipendenti.tipo;
                    if (arguments[1]){
                        if (listDipendenti.selectionAppearance=="checkbox"){
                            arguments[1] += 'listDipendenti.sortAndGroup();';
                            listDipendenti.ritorna = false;
                        }                    }
                    this.Super('fetchData',arguments);
                    wao.addTimeCallback("conteggio", wao.refNum, 100, 10, true);
                }
            },
            setDataAndFields: function(data){
                if(dipeSource.flds){
                    listDipendenti.setFields(dipeSource.flds);
                    listDipendenti.refreshFields();
                }
                if (wao.isDef(data.data)){
                    listDipendenti.setData(data.data); 
                }else{
                    listDipendenti.setData(data); 
                }
                listDipendenti.rscroll.update();
            },
            nfetch: function(){
                if (arguments[0]){
                   this.flds = arguments[0];
                }else{
                    this.flds = null;
                }
                var crit = {
                    codice:wao.getCodDitta(),
                    cod_ditta: wao.getCodDitta(),
                    escludi_cessati: escludi_cessati.getValue()
                };
                if (!this.flds){
                    crit.periodo = wao.getPeriodo();
                }
                try{
                    dipeSource.fetchData(crit,"dipeSource.setDataAndFields(data);");
                }catch(errore){ }
            }
        });
        return true;
    }
    return false;
}
// }}}
// Mostra form segnalazioni {{{
function mostraFormSegnalazioni(){
    isc.stdDialog.create({
        ID:'wndSegnalazioni',
        buttons:[isc.Dialog.CONFIRM,isc.Dialog.CANCEL],
        width:600,
        height:240,
        confirm: function(){
            if (frmSegnalazioni.validate()){
                this._toolBar.getButton(0).setDisabled(true);
                var params = frmSegnalazioni.getValues();
                params.debug_log = wao.debug_log;
                newSendData({
                    url: 'app/utenti/invia_segnalazione',
                    params: params,
                    callback:function(data){
                        if (!_lastResponse.hasErrors){
                            wndSegnalazioni.destroy();
                        }else{
                            wndSegnalazioni._toolBar.getButton(0).setDisabled(false);
                        }
                    }
                });
            }
        },
        items:[isc.DynamicForm.create({
            ID:'frmSegnalazioni',
            autoFetchData:false,
            top:10,
            cellPadding:4,
            numCols:2,
            height:40,
            wrapItemTitles: false,
            width:"*",
            fields:[
                {name:'email', title:'Email-Mittente', type:'text', required:true, width:250,
                    validators:[
                        {
                            type:'regexp', 
                            expression:/^([a-zA-Z0-9_.\-+])+@(([a-zA-Z0-9\-])+\.)+[a-zA-Z0-9]{2,4}$/,
                            errorMessage:'Inserire una email valida'
                        }
                    ]
                },
                {name:'telefono', title:'Telefono per contatti', type:'text', required:false, width:250},
                {
                    name:"cod_ditta",
                    title:'Ditta',
                    type:'select',
                    width:250,
                    optionDataSource:"ditteSource",
                    pickListWidth:250,
                    displayField :'descrizione',
                    defaultToFirstOption: true
                },
                {name:'testo', title:'Segnalazione', type:'textarea',required: true, width:500, height:150}
            ]
        })]
    });

}
// }}}
function eseguiLogout(){
    wao.eseguiLogout();
}
// vim:fdm=marker
