/**
 *  Modulo per la gestione delle preferenze utente
 */
function creaPreferenzeUtente (){
    isc.DataSource.create({
        ID:'aziendeSource',
        dataFormat:"json",
        dataURL: _gApp('utenti', 'getAziendeListUser')
    });
    isc.ListGrid.create({
        ID:"lstAziende",
        canEdit: true,
        canSort: false,
        canReorderFields: false,
        canGroupBy: false,
        showHeaderContextMenu: false,
        fields:[
            {name:'codice',title:'Codice',width:65},
            {name:'descrizione',title:'Descrizione'}
        ],
        rowClick: function (record, recordNum, fieldNum){
            isc.DataSource.create({
                ID:'preferenzeSource',
                dataFormat:"json"
            });
            preferenzeSource.dataURL= _gApp('utenti', 'getUserPref',{
                id_utente: record.id,
                id_genitore: wao.up.id
            });
            preferenzeSource.fetchData(null, 'lstOpzioni.setData(data)');
            formPreferenze.fetchData({user_id: record.id});
        },
        doubleClick: function(){}
    });
    isc.ListGrid.create({
        ID:"lstOpzioni",
        emptyMessage: "",
        canEdit: true,
        fields:[
            {name:'nome',title:'Nome'},
            {name:'valore',title:'Valore'}
        ],
        chiediOpzione: function(){
            isc.Window.create({
                ID: "wndOpzioni",
                title: "Insrimento opzione",
                autoSize:true,
                autoCenter: true,
                isModal: true,
                showModalMask: true,
                autoDraw: true,
                canDragReposition: true,
                canDragResize: true,
                items:[
                    isc.DynamicForm.create({
                        ID:"frmOpzioni",
                        fields:[
                            {name:'nome',title:'Nome',required:true},
                            {name:'valore',title:'Valore'}
                        ]
                    }),
                    isc.Toolbar.create({
                        align:"right",
                        height:25,
                        membersMargin: 6,
                        buttons:[
                            isc.IButton.create({autoFit: true,title:"Conferma",click:"lstOpzioni.inserisciRecord(frmOpzioni.getValues());"}),
                            isc.IButton.create({autoFit: true,title:"Annulla", click:"wndOpzioni.destroy();"})
                    ]})
                ]
            });
        },
        inserisciRecord: function(valori){
            this.addData(valori);
            wndOpzioni.destroy();
        }
    });
     isc.DataSource.create({
        ID:'opzioniSource',
        dataFormat:"json",
        dataURL: _gApp('utenti', 'getUserOptions'),
        fields:[
            {name: "seleziona_tutti", type:"boolean"},
            {name: "calendario_verticale", type:"boolean"},
            {name: "ordinamento", type:"integer"},
            {name: "tipo_ordinamento", type:"boolean"},
            {name: "is_sessantesimi", type:"boolean"}
        ]
    });
    isc.DynamicForm.create(
        {
            ID: 'formPreferenze',
            VerticalAlignment: "top",
            wrapItemTitles: false,
            dataSource: "opzioniSource",
            autoFetchData: true,
            //useAllDataSourceFields: true,
            fields: [
            {
                name: 'seleziona_tutti',
                title: 'Seleziona Tutti i dipendenti in entrata',
                labelAsTitle: true,
                showLabel: false,
                colSpan: 2,
                type: 'boolean',
                allowEmptyValue: true
            },
            {
                name: 'calendario_verticale',
                title: 'Calendario Verticale',
                labelAsTitle: true,
                showLabel: false,
                colSpan: 2,
                type: 'checkbox',
                allowEmptyValue: true
            },
            {
                name: 'ordinamento',
                title: 'Ordinamento gestione Presenze',
                editorType: "comboBox",
                valueMap: {
                    "0": "Default",
                    "1": "Rif pos. Inail/Codice",
                    "2": "Qualifica/Codice",
                    "3": "Centro di Costo/Codice",
                    "4": "Codice Identificativo (ID)",
                    "5": "Alfabetico",
                    "6": "Rif pos. Inail/Cognome Nome",
                    "7": "Qualifica/Cognome Nome",
                    "8": "Centro di Costo/Cognome Nome",
                    "9": "Codice"
                }
            },
            {
                name: 'tipo_ordinamento',
                title: 'Ordina con raggruppamento',
                labelAsTitle: true,
                showLabel: false,
                colSpan: 2,
                type: 'checkbox',
                allowEmptyValue: true
            },
            {
                name: 'is_sessantesimi',
                title: 'Sessantesimi',
                labelAsTitle: true,
                showLabel: false,
                colSpan: 2,
                type: 'checkbox',
                allowEmptyValue: true
            }]
    });
    isc.VLayout.create({
        ID:"frmPreferenzeRight",
        members:[
            formPreferenze,
            lstOpzioni
        ]
    });
    isc.HLayout.create({
        ID:"frmPreferenze",
        members:[
            lstAziende,
            frmPreferenzeRight
        ]
    });
    wao.getBottoni([
        {title:"Aggiorna", click:"salvaPreferenze()"},
        {title:"Aggiungi opzione",click:"lstOpzioni.chiediOpzione();"},
        {title:"Elimina opzione",click:"eliminaOpzione()"}
    ]);
    wao.addSezione('Preferenze',frmPreferenze);
    aziendeSource.fetchData(null,"lstAziende.setData(data);selezionaPrimoUtente()");
    wao.mostraFiltri(false);
    salvaPreferenze = function () {
        var dati = {
            opzioni:formPreferenze.getValues(), 
            preferenze:lstOpzioni.data
        };
        var params= {
            id_genitore: wao.up.id, 
            id_utente: lstAziende.getSelectedRecord().id
        };
        newSendData({
            params: params,
            url: "app/utenti/aggiornaPreferenze",
            dati:dati, toJSON:true,
            callback: function(data){
                wao.getUserPref();
            }
        });
    };
    eliminaOpzione = function () {
        opzione = lstOpzioni.getSelectedRecord();
        if(opzione) {
            if(opzione.id) {
                dati = {id_opzione: opzione.id};
                newSendData({
                    url: 'app/utenti/eliminaPreferenza',
                    dati:dati, toJSON:true});
            }
            idx = lstOpzioni.getRecordIndex(opzione);
            lstOpzioni.removeRecord(idx);
        }
        wao.getUserPref();
    };
    selezionaPrimoUtente = function () {
        // Seleziono e carico i parametri del primo utente
        id = 0;
        lstAziende.selectSingleRecord(id);
        r = lstAziende.getSelectedRecord();
        lstAziende.rowClick(r, id, 0);
    };
}
function cambioPassword(id_utente){
    id_utente = id_utente || wao.up.id;
    var titolo = "Password attuale";
    if (id_utente && wao.up.livello == 60){
        titolo = "Password studio";
    }
    isc.stdDialog.create({
        title:"Cambio Password",
        ID:"wndCambioPassword",
        id_utente: id_utente,
        width:278,
        height:157,
        showCloseButton:false,
        showMaximizeButton: false,
        showMinimizeButton:false,
        autoCenter: true,
        atuoSize:true,
        headerIcon: "/img/icons/key.png",
        icon: "/img/icons/key.png",
        headerIconDefaults:{
            height: 15,
            layoutAlign: "center",
            width: 15,
            src: "/img/icons/key.png"
        },
        buttons:[isc.Dialog.CONFIRM,isc.Dialog.CANCEL],
        items:[
            isc.DynamicForm.create({
                margin:5,
                wrapItemTitles :false,
                autoDraw:false,
                fields:[
                    {title:titolo, name:'apass', type:"password", required:true},
                    {title:"Nuova password",name:'npass', type:"password", required:true},
                    {title:'Conferma passwd', name:'cpass', type:"password",  required:true}
                ]
            })
        ],
        confirm: function(){
            if(this.items[0].validate()){
                var record = this.items[0].getValues();
                if (this.id_utente){
                    record.id_utente = this.id_utente;
                }
                newSendData({
                    url: 'app/utenti/cambio_password',
                    params:record,
                    callback:function(data){
                        if (!_lastResponse.hasErrors) {wndCambioPassword.hide();}
                    }
                });
                return false;
            }
            return false;
        }
    });
}

