/**
 *  modulo per la preimpostazione degli eventi e voci nelle presenze
*/

function mostraPreimpostaEventiVoci(){
    
    isc.DataSource.create({
        ID:"dsFinta",
        clientOnly: true,
        fields: [
            {name:'id_evento', primary_key:true, hidden:true},
            {name:'codice_evento', title: "Causale", width:"5%",characterCasing: "upper",
             required:true,
             keyPress: function (item, form, keyName, characterValue){
		     if (keyName == 'f6' || keyName == 'f8'){
                getListaCausali(form.getItem(item),_lCausaliEventi);
                return false;
		     }},
             doubleClick: function (form, item) {
                getListaCausali(form.getItem(item),_lCausaliEventi);
             }
            },
            {name:'descrizione', title: "Descrizione", width:"45%", canEdit:false},
            {name:'data_inizio', title: "Data inizio", width:"20%", type:"date", 
                editorType:"WaoDateItem", autocomplete:'periodo',
                required:true, formatCellValue:"wao.toData(value);" },
            {name:'data_fine', title: "Data fine", width:"20%", type:"date",
                editorType:"WaoDateItem",autocomplete:'periodo',required:true,
                formatCellValue:'wao.toData(value);'
            },
            {name:'ore_evento', title: "Ore", width:"10%", cellAlign:"right", 
                formatCellValue : "wao.formatCellNumerico(value);",
                formatEditorValue : "wao.formatEditorNumerico(value);"
            }
        ],
        data:[{
            codice_evento:'',
            descrizione:'',
            data_inizio:'',
            data_fine:'',
            ore_evento:''
        }]
        
    });
    
    var _eventi=isc.ListEventi.create({
        send_task:"gestione_eventi_multi",
        autoShow:false,
        width:"100%",
        height:"100%",
        listEndEditAction: "next",
        dataSource:"dsFinta",
        autoSaveEdits: false,
        saveLocally: true,
        saveEdits:function(){},
        deleteEdits: function(){},
        validateByCell:true,
        confirm:function(){
            for (var i = 0; i < this.getTotalRows ();i++){
                if (!this.verificaRiga(i)) {return false;}
                var r = this.getEditedRecord(i);
                if (r){
                    if(r.codice_evento){
                        if (typeof(r.data_inizio) == "object"){
                            r.data_inizio = r.data_inizio.toEuropeanShortDate();
                        }
                        if (typeof(r.data_fine) == "object"){
                            r.data_fine = r.data_fine.toEuropeanShortDate();
                        }
                        r.stato = "salva";
                        r.id_dipte = listDipendenti.getIdList();
                        newSendData({
                            get:{type:this.send_type,task:this.send_task},
                            params: r,
                            callback: null
                        });
                    }
                }
            }
            this.setData([{}]);
            return true;
        }
    });
    _eventi.addData({});
    
    isc.DataSource.create({
        ID:"dsFinta2",
        clientOnly: true,
        fields: [
            {name:'id_voce', primaryKey: true, hidden:true},
            {name:"prefisso", title:"P", width:"2%",
             keyPress: function (item, form, keyName, characterValue){
		     if (keyName == 'f6' || keyName == 'f8'){
                getListaVoci(form.getItem(item), [
                    {codice:"Nulla",descrizione:"",id:1},
                    {codice:"A",descrizione:"Arretrato",id:2},
                    {codice:"R",descrizione:"Recupero",id:3}
                    ]);
                return false;
		     }},
            
             doubleClick: function (form, item) {
                getListaVoci(form.getItem(item),  [
                    {codice:"Nulla",descrizione:"",id:1},
                    {codice:"A",descrizione:"Arretrato",id:2},
                    {codice:"R",descrizione:"Recupero",id:3}
                    ]);
             }
            },
            {name:"voce", title:"Voce", width:"5%",required:true,
             keyPress: function (item, form, keyName, characterValue){
		     if (keyName == 'f6' || keyName == 'f8'){
                getListaVoci(form.getItem(item), _lVoci);
                return false;
		     }},
            
             doubleClick: function (form, item) {
                getListaVoci(form.getItem(item), _lVoci);
             }
            },
            {name:"suffisso", title:"S", width:"2%",
             keyPress: function (item, form, keyName, characterValue){
		     if (keyName == 'f6' || keyName == 'f8'){
                getListaVoci(form.getItem(item), [
                    {codice:"Nulla",descrizione:"",id:1},
                    {codice:"A",descrizione:"Accantonamento",id:2}
                    ]);
                return false;
		     }},
            
             doubleClick: function (form, item) {
                getListaVoci(form.getItem(item),  [
                    {codice:"Nulla",descrizione:"",id:1},
                    {codice:"A",descrizione:"Accantonamento",id:2}
                    ]);
             }
            },
            {name:'descrizione', title: "Descrizione", width:"30%", canEdit:false},
            {name:"dato_base", title:"Dato base",cellAlign:"right", 
                formatCellValue:"wao.formatCellNumerico(value);",
                formatEditorValue:"wao.formatEditorNumerico(value);"
            },
            {name:"costo_unitario", title:"C. Unitario", cellAlign:"right", 
                formatCellValue:"wao.formatCellNumerico(value);",
                formatEditorValue:"wao.formatEditorNumerico(value);"
            },
            {name:"perc", title:"%", width:"5%", cellAlign:"right",
                formatCellValue:"wao.formatCellaPercent(value);",
                formatEditorValue:"wao.formatEditorPercent(value);"
            },
            {name:"importo", title:"Importo", 
                formatCellValue:"wao.formatCellNumerico(value);", cellAlign:"right",
                formatEditorValue:"wao.formatEditorNumerico(value);"
            }
        ]
    });
    
    var _voci = isc.ListaVoci.create({
	    send_task:"gestione_voci_multi",
        autoShow:false,
        width:"100%",
        height:"100%",
        listEndEditAction: "next",
        dataSource:"dsFinta2",
        autoSaveEdits: false,
        saveLocally: true,
    	saveEdits:function(){},
        deleteEdits: function(){},
        canEdit: wao.isAperto(),
        confirm:function(){
            for (var i = 0; i < this.getTotalRows ();i++){
                if (!this.validateRow(i)) return false;
                r = this.getEditedRecord(i);
                if (r.voce){
                    r.stato = 'salva';
                    r.id_dipte = listDipendenti.getIdList();
                    newSendData({
                        get:{type:this.send_type,task:this.send_task},
                        params:r,
                        callback:null
                    });
                }
            }
            this.setData([{}]);
            return true;
        }
    });
    
    _voci.addData({});
    
    var _note = isc.DynamicForm.create({
        autoFetchData:false,
        autoDraw:false,
        width:"100%",
        height:"100%",
        canSubmit:false,
        fields:[{
            name:"nota",
            title:"Note",
            length: 1000,
            type:"textArea",
            width:"*",
            height:"*"
        }],
	confirm: function(){
	    newSendData({
            url: 'app/presenze/gestione_note_multi',
            params:{
                stato:'salva',
                nota: this.getField('nota').getValue(),
                id_dipte: listDipendenti.getIdList()
            }
        });
	    this.getField('nota').setValue('');
	}
    });
    var lista_tabs = [
        {align:"left",title:"Eventi", pane:_eventi},
        {align:"left",title:"Voci", pane:_voci},
        {align:"left",title:"Note",pane:_note}
    ];
    var _tabs = isc.TabSet.create({tabBarPosition:"top", tabs:lista_tabs, height:375,width:"100%"});
    isc.stdDialog.create({
        ID: "dlgImpostaEVN",
        title:"Preimposta Eventi/Voci/Note",
        buttons:[
            Dialog.APPLY,
            Dialog.CLOSE
        ],
        items:[_tabs],
        applyClick: function(){
            this.items[0].getSelectedTab().pane.confirm();
        }
    });
    
    dlgImpostaEVN.show();
    
}

