/**
 *  Modulo per le presenze
 */
function caricaCausaliEventiVoci(){
    if (typeof(listDipendenti)!="undefined"){
        if (listDipendenti.tipo=='presenze'){
            if (typeof(sourceCausali) == "undefined"){
                isc.DataSource.create({
                    ID: "sourceCausali", dataFormat: "json",
                    dataURL: '/app/gestione/getCausaliCalend'
                });
            }
            if (typeof(sourceCausaliEventi) == "undefined"){
                isc.DataSource.create({
                    ID: "sourceCausaliEventi", dataFormat: "json",
                    dataURL: '/app/gestione/getCausali'
                });
            }
            if (typeof(sourceVoci) == "undefined"){
                isc.DataSource.create({
                    ID: "sourceVoci", dataFormat: "json",
                    dataURL: '/app/gestione/getVoci'
                });
            }
            if (typeof(sourceCentriCosto) == "undefined"){
                isc.DataSource.create({
                    ID: "sourceCentriCosto", dataFormat: "json",
                    dataURL: '/app/gestione/getCentriCosto'
                });
            }
            if(wao.getPeriodo()){
                var filtro = {cod_ditta:wao.getCodDitta(), codice:wao.getCodDitta(), periodo:wao.getPeriodo()};
                if (sourceCausali.compareCriteria(_lastFiltro,filtro)!==0){
                    sourceCausali.fetchData(filtro,"_lCausali=data;");
                    sourceCausaliEventi.fetchData(filtro,"_lCausaliEventi=data;");
                    sourceVoci.fetchData(filtro,"_lVoci=data;");
                    sourceCentriCosto.fetchData(filtro,"_lCentriCosto=data;");
                    _lastFiltro = filtro;
                }
            }
        }
    }   
}

function creaAnagrafichePresenze() {
    var stampa = arguments[0] || false;
    _lastGriglia = null;
    wao.refreshCallback(['findForm']);
    try{cuboPresenza.destroy();} catch(errore){}
    try{delete cuboPresenza;} catch(errore_1){}
    dipeSource.defaultParams.stato = 'lista';
    dipeSource.defaultParams.archivio = 'p';
    getListaDipe('presenze');
    //var ricarica = dipeSource.compareCriteria(listDipendenti.last_filtro, findForm.getValuesAsCriteria()) !== 0;
    var ricarica = wao._lastAzione.indexOf('creaAnagrafichePresenze') !== -1;
    if (!stampa){
        wao.addSezione("Presenze", listDipendenti);
        wao.getBottoni([
            {consel:true, title: "Gestione Presenze", click: "creaCuboPresenze({});"}, 
            {consel:true, title: "Singolo Dipendente", click: "creaCuboPresenze({singolo:true,orientamento:wao.up.imp.orientamento});"}, 
            {consel:true, title: "Riassuntivo", click: "mostraRiassuntoDipe();"}, 
            {nomodp:true, consel:true, title: "Preimposta", click: "mostraPreimpostaEventiVoci();", disabled:!wao.isAperto()},  
            {title: "Esci", click: "document.location='/';"}
        ]);
        wao.addTimeCallback('abilitaPreimposta',"toolBottoni.getButton(3).setDisabled(!wao.isAperto());", 100,50);
    }else{
        wao.addSezione(stampa, listDipendenti);
    }
    if ((listDipendenti.tipo != dipeSource.tipo)){
        wao.aggiornaPeriodo();
        dipeSource.nfetch(null);
        if (!stampa){
            toolBottoni.getButton(3).setDisabled(!wao.isAperto());
        }
    }else{
        findForm.findItems();
        if (!stampa){
            toolBottoni.getButton(3).setDisabled(!wao.isAperto());
        }
    }
    listDipendenti.last_tipo = listDipendenti.tipo;
    wao.removeTimeCallback('hasDomicilio');
    wao.mostraFiltri({cessati:false});
}

function stampaPresenze(){
    window.open(_gApp("presenze", "stampa", {id_dipte:listDipendenti.getIdList()}));
}

function verificaCalendario(condipe) {
    var u = {};
    if (condipe) {u.id_dipte = wao.getIdDipe();}
    newSendData({url:'app/presenze/verifica_calendario', params:u});
}

function salvaCalendario(callback) {
    var u = {};
    var ncallback = null;
    if(callback){
        ncallback = function(){if(!_lastResponse.hasErrors){callback();}};
    }
    newSendData({
        url: 'app/presenze/salva_calendario',
        callback:ncallback
    });
}

function annullaModificheCalendario(callback){
    var u = {};
    var ncallback = null;
    if(callback){
        ncallback = function(){if(!_lastResponse.hasErrors){callback();}};
    }
    newSendData({
        url: 'app/presenze/annulla_modifiche',
        callback:ncallback
    });
}

function creaStatus() {
    var cod_ditta = findCodice.getValue();
    dipeSource.defaultParams.stato = 'lista';
    try{listDipendenti.tipo = "forzaLista";}catch(errore_st){}
    isc.DataSource.create({
        ID: "lstPeriodiSource",
        dataFormat: "json",
        dataURL: '/app/anagrafiche/status_ditta',
        autoFetchData: false,
        fields: [
        {name: "id", required: true, hidden: true},
        { name: 'periodoStatus', formatCellValue:"wao.intToDataStr(value);"},
        { name: 'statoStatus' },
        { name: 'inviatoStatus' }]
    });
    isc.VLayout.create({
        ID: "layStatus",
        width: "100%",
        autoDraw: false,
        members: [
        isc.ListGrid.create({
            ID: "lstPeriodi",
            dataSource: "lstPeriodiSource",
            alternateRecordStyles: true,
            showAllRecords: true,
            wrapCells: true,
            fixedRecordHeights: false,
            canDragRecordsOut: false,
            canReorderRecords: false,
            canAcceptDroppedRecords: false,
            hoverWidth: 200,
            hoverHeight: 20,
            selectionType: "single",
            autoDraw: false,
            autoFetchData: false,
            autoSaveEdits: false,
            canEdit: true,
            editEvent: "click",
            editByCell: true,
            sortField: 'periodoStatus',
            sortDirection: "descending",
            fields: [
            { name: "periodoStatus", title: "Periodo", width: "20%", canEdit: false },
            { name: "statoStatus", title: "Stato", width: "40%", valueMap: ["Aperto", "Chiuso"]},
            { name: "inviatoStatus", title: "Inviato", width: "40%", valueMap: {"S":'Si', "N":'No'} }],
            canEditCell: function (rowNum, colNum) {
               var record = this.getRecord(rowNum);
               var fieldName = this.getFieldName(colNum);
               if (fieldName == 'statoStatus' && record.statoStatus == 'Aperto'){
                   //alert("Usare Presenze/Chiudi mese per chiudere un mese.");
                   return false;
               }
               if (fieldName == 'inviatoStatus' && record.inviatoStatus == 'N'){
                   //alert("Usare Connessioni/Invia per inviare un mese.");
                   return false;
               }
               return this.Super('canEditCell', arguments);
            },
            salvaPeriodi: function(){
                for (var i = 0; i < this.getTotalRows();i++){
                    var valori = this.getEditedRecord(i);
                    if (valori){
                        newSendData({
                            url: 'app/presenze/cambia_stato',
                            params: valori
                        });
                    }
                }
                wao.aggiornaPeriodo();
                lstPeriodi.aggiornaLista();
            },
            eliminaPeriodo: function(){
                var record = this.getSelectedRecord();
                if (record){
                    if( confirm("Eliminare il periodo " + record.periodoStatus + " ? ")){
                        newSendData({
                            url:'/app/anagrafiche/elimina_periodo',
                            params:{periodo_id: record.id_periodo},
                            showPrompt: false,
                            promptStyle: "cursor",
                            tipo:"xml",
                            callback: function(data){
                                wao.aggiornaPeriodo();
                                lstPeriodi.aggiornaLista();
                            }
                        });
                    }
                }
            },
            aggiornaLista: function(){
                this.setData([]);
                this.fetchData({cod_ditta: wao.getCodDitta()});
            }
        })]
    });
    //lstPeriodiSource.fetchData({codice:wao.getCodDitta()},"lstPeriodi.setData(data);");
    //wao.addRefCallback("status",function(){
        //if (lstPeriodi.isVisible()){
            //lstPeriodiSource.fetchData({cod_ditta:wao.getCodDitta()},"lstPeriodi.setData(data);");
        //}
    //});
    wao.addSezione("Status", layStatus);
    wao.getBottoni([{title: "Aggiorna", click: "lstPeriodi.salvaPeriodi();" }, 
        {title: "Elimina", click:"lstPeriodi.eliminaPeriodo();" },
        {title: "Esci", click:"document.location='/'" }]);
    wao.mostraFiltri({nominativo:false,periodo:false,cessati:false});
    _lastGriglia = lstPeriodi;
    lstPeriodi.fetchData({cod_ditta:wao.getCodDitta()});
}

function creaApriMese() {
    if (wao.needPeriodi()){creaStatus();}
    wao._lastNode = null;
    isc.DataSource.create({
        ID: "sourceApriMese",
        dataFormat: "xml",
        dataURL: '/app/presenze/apri_mese',
        recordXPath: "/apriMese/periodo",
        fields: [{ name: 'periodo'}]
    });
    isc.stdDialog.create({
        title: "Apertura mese",
        ID: "wndApriMese",
        confirm: function(){
            if (apriMeseForm.getField('periodo').validate()){
                this.getButton(0).setDisabled(true);
                newSendData({
                    url: 'app/presenze/apri_mese',
                    params: apriMeseForm.getValues(),
                    callback:function(){
                        if (!_lastResponse.hasErrors){
                            wao.aggiornaPeriodo();
                            lstPeriodi.aggiornaLista();
                            findForm.findItems();
                            wndApriMese.hide();
                        }
                    }
                });
            }
            return false;
        },
        height:100,
        buttons:[isc.Dialog.CONFIRM,isc.Dialog.CANCEL],
        items:[isc.DynamicForm.create({
            ID:'apriMeseForm',
            autoFetchData:false,
            top:10,
            cellPadding:4,
            numCols:8,
            height:40,
            fields:[
            {
                name:"cod_ditta",
                title:'Ditta',
                type:'select',
                width:250,
                optionDataSource:"ditteSource",
                pickListWidth:250,
                displayField :'descrizione',
                defaultToFirstOption: true,
                changed: "form.cambiaPeriodo();"
            },
            {
                name:"periodo",
                title:'Periodo',
                type:"text",
                length: 7,
                width:100,
                autoDraw: true,
                validators:[wao.validators.periodo]
            }],
            cambiaPeriodo: function(){
                var cod = this.getField('cod_ditta').getValue();
                sourceApriMese.fetchData({cod_ditta:cod},
                        "apriMeseForm.getField('periodo').setValue(data);" +
                        "findCodice.setValue('"+cod+"');" +
                        "findForm.findItems();" + "infoTop.setContenuto();");
            }
        })]
    });
    apriMeseForm.getField('cod_ditta').setValue(wao.getCodDitta());
    apriMeseForm.cambiaPeriodo();
    //wao.addRefCallback("apriMese","if(apriMeseForm.isVisible())apriMeseForm.cambiaPeriodo();");
    //wao.refreshCallback();
}

function creaChiudiMese(){
    if (wao.needPeriodi()){creaStatus();}
    wao._lastNode = null;
    isc.stdDialog.create({
        ID:'wndChiudiMese',
        title: "Chiusura mese",
        confirm: function(){
            newSendData({
                url: 'app/presenze/chiudi_mese',
                params: chiudiMeseForm.getValues(),
                callback:function(){
                    if (!_lastResponse.hasErrors){
                        wndChiudiMese.hide();
                        wao.aggiornaPeriodo();
                        lstPeriodi.aggiornaLista();
                    }
                }
            });
            return false;
        },
        height:100,
        buttons:[isc.Dialog.CONFIRM,isc.Dialog.CANCEL],
        items:[isc.DynamicForm.create({
            ID:'chiudiMeseForm',
            autoFetchData:false,
            top:10,
            cellPadding:4,
            numCols:8,
            height:40,
            fields:[
            {
                name:"cod_ditta",
                title:'Ditta',
                type:'select',
                width:250,
                optionDataSource:"ditteSource",
                pickListWidth:250,
                displayField :'descrizione',
                defaultToFirstOption: true,
                changed: "form.cambiaPeriodo();chiudiMeseForm.cambiaPeriodo();"
            },
            {
                name:"periodo",
                title:'Periodo',
                type:"select",
                width:250,
                pickListWidth:250,
                displayField :'periodo',
                fetchMissingValues: true,
                defaultToFirstOption: true,
                autoDraw: true,
                optionDataSource: "periodiSource",
                getPickListFilterCriteria:function(){
                    return {cod_ditta:this.cod,filtra:"A"};
                }
            }],
            cambiaPeriodo: function(){
                var p = this.getField('periodo');
                p.cod = this.getField('cod_ditta').getValue();
                p.fetchData();
                p.setTop();
            }
        })]
    });
    chiudiMeseForm.getField('cod_ditta').setValue(wao.getCodDitta());
    chiudiMeseForm.cambiaPeriodo();
}

function creaAnagraficheStampe() {
    creaAnagrafichePresenze("Stampa presenze");
    wao.getBottoni([
        {consel: true, title: "Stampa Presenze", click: "stampaPresenze();" },  
        {title: "Esci", click: "document.location='/';" }
    ]);
}

function getListaCausali(item,cheSource){
	// impostazione no select oggetto editor
    try{item.elemento.noSelect = true;}catch(erre){}
    isc.ListGrid.create({
    ID: "lstCausali",
    cheSource: cheSource,
    alternateRecordStyles: true,
    showAllRecords: true,
    wrapCells: false,
    fixedRecordHeights: false,
    canDragRecordsOut: false,
    canReorderRecords: false,
    canSort: true,
    canAcceptDroppedRecords: false,
    hoverWidth: 200,
    hoverHeight: 20,
    selectionType: "single",
    autoFitData: "horizontal",
    cheItem: item,
    width: 595,
    height: 380,
    selRec: 0,
    fields: [
        {name: 'codice', title: 'Codice' },
        {name: 'descrizione', title: 'Descrizione' }
    ],
    recordDoubleClick: function recordDoubleClick(viewer, record, recordNum, field, fieldNum, value, rawValue) {
       this.topElement.confirmClick(); 
    },
    getPointer: function(){
        var trovato = false;
        for (i = 0; i < this.getTotalRows(); i++){
        if (this.cheItem.getValue()==this.getRecord(i).codice){
            this.selectRecord(i);
            this.selRec = i;
            this.scrollToRecord();
            break;
        }
        }
    },
    scrollToRecord:function(){
        this.redraw(this.draw());
        var rowHeight = this.getRowHeight();
        this.body.scrollTo(0,this.selRec*rowHeight);
    }
    });
    isc.stdDialog.create({
        ID: "wndValori",
        title: "Ricerca",
        width: 600,
        height: 400,
        cheItem: item,
        autosize: true,
        confirm: function(){
            var valore = this.cheItem.getValue();
            if (valore){
                var m = valore.match(/^(\d\d)(\s.+)$|^(\w\w)(.*)$/);
                if (m){
                   valore = m[2]?m[2]:m[4];
                } else{
                    valore = '';
                }
            }else{
                valore = '';
            }
            var value = lstCausali.getSelectedRecord().codice;
            this.cheItem.setValue(value);
            var causale = cheSource.find('codice', value.toUpperCase());
            if (causale){
                try{
                    this.cheItem.grid.setEditValue(item.rowNum,"descrizione", causale.descrizione);
                }catch(errore){}
            }
			// disabilitazione focus oggetto editor
            wao.addTimeCallback(null,this.cheItem.ID + ".deselect();",10,1);
            return true;
        },
        buttons:[Dialog.CONFIRM,Dialog.CANCEL],
        items: [
            isc.SearchForm.create({
                ID: "findValori",
                top: 10,
                cellPadding: 0,
                numCols: 1,
                fields: [{
                    name: "elemento",
                    title: 'Filtro',
                    icons: [{
                    src: "/img/demoApp/icon_view.png",
                    click: "findValori.findItems();"
                    }]
                }],
                findItems: function(categoryName) {
                    var valore = this.getField('elemento').getValue();
                    if (valore){
                        lstCausali.setData(lstCausali.cheSource.map(function(item,index,array){
                            if (item.descrizione.toLowerCase().indexOf(valore.toLowerCase())!=-1){
                                return item;
                            }
                        }).findAll('elemento'));
                    }else{
                        lstCausali.setData(lstCausali.cheSource);
                    }
                }
            }),
            lstCausali
        ]
    });
    lstCausali.setData(lstCausali.cheSource);
    lstCausali.getPointer();
    wndValori.show();
}

function getListaVoci(item,cheSource) {
    //if (cheSource === null) { caricaCausaliEventiVoci(); }
    isc.ListGrid.create({
    ID: "lstVoci",
    alternateRecordStyles: true,
    cheSource: cheSource,
    showAllRecords: true,
    wrapCells: false,
    fixedRecordHeights: false,
    canDragRecordsOut: false,
    canReorderRecords: false,
    canSort: true,
    canAcceptDroppedRecords: false,
    hoverWidth: 200,
    hoverHeight: 20,
    selectionType: "single",
    autoFitData: "horizontal",
    cheItem: item,
    width: 595,
    height: 380,
    selRec: 0,
    fields: [
        { name: 'codice', title: 'Codice' },
        { name: 'descrizione', title: 'Descrizione' }
    ],
    recordDoubleClick: function recordDoubleClick(viewer, record, recordNum, field, fieldNum, value, rawValue) {
       this.topElement.confirmClick(); 
    },
    getPointer: function(){
        var trovato = false;
        for (i = 0; i < this.getTotalRows(); i++){
            if (this.cheItem.getValue()==this.getRecord(i).codice){
                this.selectRecord(i);
                this.selRec = i;
                this.scrollToRecord();
                break;
            }
        }
    },
    scrollToRecord:function(){
        this.redraw(this.draw());
        var rowHeight = this.getRowHeight();
        this.body.scrollTo(0,this.selRec*rowHeight);
    }
    });
    lstVoci.cheItem = item;
    isc.stdDialog.create({
        ID: "wndValori",
        title: "Ricerca",
        align: "left",
        width: 600,
        height: 400,
        autoSize: true,
        cheItem: item,
        buttons:[Dialog.CONFIRM,Dialog.CANCEL],
        confirm: function(){
            var value = lstVoci.getSelectedRecord().codice;
            this.cheItem.setValue(value);
            var voce = _lVoci.find('codice', value.toUpperCase());
            if (voce){
                listVociDipe.setEditValue(item.rowNum,"descrizione",voce.descrizione);
                }
            return true;
        },
        items: [isc.SearchForm.create({
            ID: "findValori",
            top: 10,
            cellPadding: 0,
            numCols: 1,
            fields: [{
                name: "elemento",
                title: 'Filtro',
                icons: [{
                    src: "/img/demoApp/icon_view.png",
                    click: "findValori.findItems();"
                }]
            }
            ],
            findItems: function(categoryName) {
                var valore = this.getField('elemento').getValue();
                if (valore){
                    lstVoci.setData(lstVoci.cheSource.map(function(item,index,array){
                        if (item.descrizione.toLowerCase().indexOf(valore.toLowerCase())!=-1){
                            return item;
                        }
                    }).findAll('elemento'));
                }else{
                    lstVoci.setData(lstVoci.cheSource);
                }
            }
        }), lstVoci]
    });
    wndValori.cheItem = item;
    lstVoci.setData(lstVoci.cheSource);
    lstVoci.getPointer();
    wndValori.show();
}

function mostraRiassuntoDipe(interno){
    var id_dipte = wao.getIdDipe();
    var record = listDipendenti.rscroll.record();
    interno = interno || false;
    isc.stdDialog.create({
    ID: "anaPresWin",
    title: "Riassuntivo Dipendente",
    width: 500,
    height: 270,
    //height: 400,
    //autoSize:true,
    autoCenter: true,
    isModal: true,
    showModalMask: true,
    autoDraw: true,
    autoSize: true,
    canDragReposition: true,
    canDragResize: false,
    interno: interno,
    //padding:10,
    buttons:[isc.Dialog.CONFIRM, isc.Dialog.CANCEL],
    items:[
        isc.DynamicForm.create({
            numCols:4,
            padding: 10,
            ID:"frmRiassuntivo",
            //width:"100%",
            width: 400,
            wrapItemTitles : false,
            values:{"applica": "dipe"},
            fields:[
                {name:'dal',title:'Dal',type:"integer",defaultValue:1, length:2, colSpan:1, textAlign:"right"},
                {name:'al',title:'Al',type:"integer",defaultValue:wao.getMaxGiorni(), length:2, colSpan:1, textAlign:"right"},
                {name:'applica',type:'radioGroup', showTitle:false,colSpan:2,
                    startRow:true,
                    endRow:true,
                    valueMap:{
                        'tutti':'Tutti',
                        'dipe':'Dipe:' + record.codice +  ' - ' + record.nominativo,
                        'selezione':'Selezione'
                    }
                },
                {name:'causali',title:'Causali',type:'checkbox',colSpan:1},
                {name:'voci',title:'Voci',type:'checkbox',colSpan:1},
                {name:'lav_dom',title:'Lavoro a domicilio',type:'checkbox',colSpan:1},
                {name:'note',title:'Note',type:'checkbox',colSpan:1},
                {name:'firma',title:'Firma per accetazione e controllo',type:'checkbox', colSpan:1}
            ]
            })
        ],
    confirm: function(){
        _mostraRiassunto(this.interno);
        return true;
    }
    });
    if (typeof cuboPresenza != "undefined"){
        if (cuboPresenza.singolo){
            frmRiassuntivo.getField('applica').hide(true);
            anaPresWin.setHeight(195);
        }else{
            var vmap = frmRiassuntivo.getField('applica').valueMap;
            delete vmap.selezione;
            frmRiassuntivo.getField('applica').setValueMap(vmap);
            anaPresWin.setHeight(250);
        }

    }
}

function _mostraRiassunto(interno){
    var infos = frmRiassuntivo.getValues();
    infos.sessione = interno || false;
    //infos.cod_ditta = wao.getCodDitta();
    switch (infos.applica){
        case 'dipe':
            infos.id_dipte = listDipendenti.rscroll.record().id;
            
            break;
        case 'selezione':
            infos.id_dipte = listDipendenti.getIdList();
            break;
        default:
            infos.id_dipte = listDipendenti.getIdList(true);
            break;
    }
    window.open(_gApp('presenze', 'stampa_riassuntivo', infos), "Riassuntivo"); 
}
//}}
// vim:fdm=marker
