/*
 * Script per la gestione del dettaglio nell'anagrafica presenze.
 * Contiene: dati anagrafici, lista degli eventi e delle voci, lista dei centri di costo, etc...
 */
// mostraDettaglioPresenze {{{
function mostraDettaglioPresenze(){
    try{
        listCampi.destroy();
    }catch(err){}
    idDipeOld = 0;
    var id_dipendente = 0;
    var record_corrente;
    if (!arguments[0]){
        try{record_corrente = _lastGriglia.getSelectedRecord();}catch(errore){record_corrente=null;}
        if(record_corrente === null) {
            record_corrente = _lastGriglia.getRecord(0);
        }
        try{id_dipendente = record_corrente.id_dipe;}catch(errore){id_dipendente = 0;}
    }else{
        id_dipendente = arguments[0];
    }
    creaGrigliaDettagliAna(findCodice.getValue(), id_dipendente);
    creaNoteDettaglioPres();
    creaEventiDettaglioPres();
    if(_lVoci){
        if(_lVoci.length===0){
            isc.HTMLFlow.create({
                ID:"listVociDipe",
                contents:'<h3 style="text-align:center;">Voci non abilitate per questa ditta.</h3>'
            });
        }else{
            creaVociDettaglioPres();
        }
    }else{
        isc.HTMLFlow.create({
            ID:"listVociDipe",
            contents:'<h3 style="text-align:center;">Voci non abilitate per questa ditta.</h3>'
        });
    }
    creaDomicilioDettaglioPres();
    try{
        listCampi.destroy();
    }catch(err){}
    var lista_tabs = [
        {align:"left",title:"Eventi", ID:"tabEventiPres", pane:"listEventiDipe"},
        {align:"left",title:"Voci", ID:"tabVociPres", pane:"listVociDipe"},
        {align:"left",title:"Note", ID:"tabNotePres", pane:"noteForm"},
        {align:"left",title:"Lavoro Domicilio", ID:"tabDomicilioPres", pane:"listDomicilioDipe", hidden: true, visible:false}
        //{align:"left",title:"Anagrafica", ID:"tabAnagraficaPres", pane:"listCampi"}
    ];
    isc.TabSet.create({
        ID:"tabDettaglioPres", 
        tabBarPosition:"top", 
        tabs:lista_tabs, height:"35%"
    });
    creaSezioneDettaglio();
    aggiornaDatiDettaglioPres(id_dipendente);
}
// }}}
// creaNoteDettaglioPres {{{
function creaNoteDettaglioPres() {
    isc.DataSource.create({
	ID: "dipeNoteSource",
	showPrompt: false,
        dataFormat: "json",
        dataURL: _gApp('presenze', 'gestione_note'),
        recordXPath: "nota"
    });
    isc.DynamicForm.create({
        ID:"noteForm",
        dataSource:"dipeNoteSource",
        autoFetchData:false,
        autoDraw:false,
        width:"100%",
        height:"100%",
        canSubmit:false,
        saveOnEnter:true,
        sistemato:function(){
            this._hasChanges=false;
            this.saveAllEdits();
        },
        _hasChanges:false,
        hasChanges:function(){
            return (this.Super("hasChanges",arguments) && this._hasChanges);
        },
        fields:[{
            ID:"notaField",
            name:"nota",
            title:"Note",
            length: 1000,
            type:"textArea",
            width:"*",
            height:"*",
            blur:"noteForm.saveData()",
            enabled: wao.isAperto()
        }],     
        saveData : function(){
            if (wao.isAperto()){
                var filtro = this.getValues();
                if (!filtro.nota){
                    filtro.nota = '';
                }
                filtro.id_dipte=idDipeOld;
                filtro.stato='salva';
                dipeNoteSource.fetchData(filtro, "noteForm.setValues(data)");
                this._hasChanges = true;
            }
        }
    });
    notaField.setDisabled(!wao.isAperto());
}
// }}}
// creaEventiDettaglioPres {{{
function creaEventiDettaglioPres() {

    isc.DataSource.create({
	ID: "dipeEventiSource",
        dataFormat: "json",
        dataURL: _gApp('presenze', 'gestione_eventi'),
        recordXPath: "evento",
        showPrompt: false,
        fields: [
            {name:'id_evento', primary_key:true, hidden:true},
            {name:'codice_evento', title: "Causale", width:"5%",characterCasing: "upper",
                required:true,
                keyPress: function (item, form, keyName, characterValue){
                     if (keyName == 'f6' || keyName == 'f8'){
                        getListaCausali(form.getItem(item),_lCausaliEventi);
                        return false;
                     }
                },
                doubleClick: function (form, item) {
                    getListaCausali(form.getItem(item),_lCausaliEventi);
                },
                change: function(form, item, value, oldValue){
                    var causale = _lCausaliEventi.find('codice', value.toUpperCase());
                    if (causale){
                        listEventiDipe.setEditValue(item.rowNum,"descrizione",causale.descrizione);
                    }
                    return this.Super('change', arguments);
                },
                changed: function(form, item, value){
                    var causale = _lCausaliEventi.find('codice', value.toUpperCase());
                    if (causale){
                        listEventiDipe.setEditValue(item.rowNum,"descrizione",causale.descrizione);
                    }
                }
            },
            {name:'descrizione', title: "Descrizione", width:"30%", canEdit:false},
            {name:'data_inizio', title: "Data inizio", width:"20%", type:"date",
                editorType:"WaoDateItem",autocomplete:'periodo',required:true,
                formatCellValue:"wao.toData(value);" },
            {name:'data_fine', title: "Data fine", width:"20%", type:"date",
                editorType:"WaoDateItem",autocomplete:'periodo',required:true,
                formatCellValue:"wao.toData(value);" },
            {name:'ore_evento', title: "Ore", width:"10%", cellAlign:"right", 
                formatCellValue : "wao.formatCellNumerico(value);",
                formatEditorValue : "wao.formatEditorNumerico(value);"
            },
            {name:'_elimina', showTitle:false, title: " ", width:20, type:'image',cellIcon:'[SKIN]/actions/remove.png',
                imageURLPrefix: "/img/",
                imageURLSuffix: ".png",
                defaultValue: 'remove',
                canEdit:false,
                recordClick: function (viewer, record, recordNum, field, fieldNum, value, rawValue){
                    viewer.deleteEdits(record.id_riga);
                },
                formatCellValue : "'<img src=\"/img/remove.png\" />'"
            }
        ]
    });
    isc.ListEventi.create({
        ID: "listEventiDipe",
        dataSource: "dipeEventiSource",
        canEdit: wao.isAperto()
    });
}
// }}}
// creaVociDettaglioPres {{{
function creaVociDettaglioPres() {
    isc.DataSource.create({
	ID: "dipeVociSource",
    autoFetchData:false,
	showPrompt: false,
        dataFormat: "json",
        dataURL: _gApp('presenze', 'gestione_voci'),
        recordXPath: "voce",
        fields: [
            {name:'id_voce', primaryKey: true, hidden:true},
            {name:"prefisso", title:"P", width:"2%",
             keyPress: function (item, form, keyName, characterValue){
		     if (keyName == 'f6' || keyName == 'f8'){
                getListaVoci(form.getItem(item), [
                    {codice:"Nulla",descrizione:"",id:1},
                    {codice:"A",descrizione:"Arretrato",id:2},
                    {codice:"R",descrizione:"Recupero",id:3}
                    ]);
                return false;
		     }},
            
             doubleClick: function (form, item) {
                getListaVoci(form.getItem(item),  [
                    {codice:"Nulla",descrizione:"",id:1},
                    {codice:"A",descrizione:"Arretrato",id:2},
                    {codice:"R",descrizione:"Recupero",id:3}
                    ]);
             }
            },
            {name:"voce", title:"Voce", width:"5%",required:true,
                 keyPress: function (item, form, keyName, characterValue){
                     if (keyName == 'f6' || keyName == 'f8'){
                        getListaVoci(form.getItem(item), _lVoci);
                        return false;
                     }
                 },
                 doubleClick: function (form, item) {
                    getListaVoci(form.getItem(item), _lVoci);
                },
                change: function(form, item, value, oldValue){
                    var voce = _lVoci.find('codice', value.toUpperCase());
                    if (voce){
                        listVociDipe.setEditValue(item.rowNum,"descrizione",voce.descrizione);
                    }
                    return this.Super('change', arguments);
                }
            },
            {name:"suffisso", title:"S", width:"2%",
             keyPress: function (item, form, keyName, characterValue){
		     if (keyName == 'f6' || keyName == 'f8'){
                getListaVoci(form.getItem(item), [
                    {codice:"Nulla",descrizione:"",id:1},
                    {codice:"A",descrizione:"Accantonamento",id:2}
                    ]);
                return false;
		     }},
            
             doubleClick: function (form, item) {
                getListaVoci(form.getItem(item),  [
                    {codice:"Nulla",descrizione:"",id:1},
                    {codice:"A",descrizione:"Accantonamento",id:2}
                    ]);
             }
            },
            {name:'descrizione', title: "Descrizione", width:"30%", canEdit:false},
            {name:"dato_base", title:"Dato base",cellAlign:"right", 
                formatCellValue:"wao.formatCellNumerico(value);",
                formatEditorValue:"wao.formatEditorNumerico(value);"
            },
            {name:"costo_unitario", title:"C. Unitario", cellAlign:"right", 
                formatCellValue:"wao.formatCellNumerico(value);",
                formatEditorValue:"wao.formatEditorNumerico(value);"
            },
            {name:"perc", title:"%", width:"5%", cellAlign:"right",
                formatCellValue:"wao.formatCellaPercent(value);",
                formatEditorValue:"wao.formatEditorPercent(value);"
            },
            {name:"importo", title:"Importo", 
                formatCellValue:"wao.formatCellNumerico(value);", cellAlign:"right",
                formatEditorValue:"wao.formatEditorNumerico(value);"
            },
            {name:'_elimina', showTitle:false, title: " ", width:20, type:'image',cellIcon:'[SKIN]/actions/remove.png',
                imageURLPrefix: "/img/",
                imageURLSuffix: ".png",
                defaultValue: 'remove',
                canEdit:false,
                formatCellValue : "'<img src=\"/img/remove.png\" />'",
                recordClick: function (viewer, record, recordNum, field, fieldNum, value, rawValue){
                    viewer.deleteEdits(record.id_riga);
                }
            }
        ]
   });
    isc.ListaVoci.create({
        ID: "listVociDipe",
        dataSource: "dipeVociSource",
        canEdit: wao.isAperto()
    });
}
// }}}
// creaDomicilioDettaglioPres {{{
function creaDomicilioDettaglioPres() {
    isc.DataSource.create({
        ID: "dipeDomicilioSource",
        dataFormat: "json",
        dataURL: _gApp('presenze', 'gestione_lav_dom'),
        recordXPath: "lavdom",
        showPrompt: false,
        fields: [
            {name:'id_lavoro', primary_key:true, hidden:true},
            {name:'data_consegna', title: "Data consegna", width:"20%", type:"date",editorType:"WaoDateItem",autocomplete:'periodo',required:false},
            {name:'ora_consegna', title: "Ora consegna", width:"20%", type:"time",required:false,displayFormat:"toShortPadded24HourTime"},
            {name:'data_riconsegna', title: "Data riconsegna", width:"20%", type:"date",editorType:"WaoDateItem",autocomplete:'periodo',required:false},
            {name:'ora_riconsegna', title: "Ora riconsegna", width:"20%", type:"time",required:false,displayFormat:"toShortPadded24HourTime"},
            {name:'descrizione', title: "Descrizione", width:"45%",required:true},
            {name:'quantita', title: "Quantit", width:"10%", cellAlign:"right"},
            {name:'_elimina', showTitle:false, title: " ", width:20, type:'image',cellIcon:'[SKIN]/actions/remove.png',
                imageURLPrefix: "/img/",
                imageURLSuffix: ".png",
                defaultValue: 'remove',
                canEdit:false,
                recordClick: function (viewer, record, recordNum, field, fieldNum, value, rawValue){
                    viewer.deleteEdits(record.id_riga);
                },
                formatCellValue : "'<img src=\"/img/remove.png\" />'"
            }
        ]
    });
    
    isc.ListaDomicilio.create({
        ID: "listDomicilioDipe",
        dataSource: "dipeDomicilioSource",
        canEdit: wao.isAperto()
    });
}
// }}}

// creaSezioneDettaglio {{{
function creaSezioneDettaglio() {
    if (cuboPresenza.orientamento == 'orizzontale'){
        rightSideLayout.removeMember(toolBottoni);
        rightSideLayout.addSection({ID:"dettPresenze", title:"Dettagli", canCollapse:true, expanded:false, items:[tabDettaglioPres]});
        rightSideLayout.addSection({ID:"sezBottoni", showHeader:false, canCollapse:false, expanded:true, items:[toolBottoni]});
    }else{
       cuboHlayout.addMember(tabDettaglioPres);
    }
}
//}}}
// aggiornaDatiDettaglioPres {{{
function aggiornaDatiDettaglioPres(id_dipendente) {
    // Aggiorno i dati del dettaglio

    // Anagrafica
    if( idDipeOld != id_dipendente){
        try{
            idDipeOld = id_dipendente;
            infoDipePresenze.setContenuto(listDipendenti.rscroll.getRecord(id_dipendente));
            listDipendenti.rscroll.setRecord(id_dipendente);
            //campiSource.fetchData({id_dipte:id_dipendente}, "listCampi.setData(data)");
            dipeNoteSource.fetchData({id_dipte:id_dipendente}, "noteForm.setValues(data)");
            dipeEventiSource.fetchData({id_dipte:id_dipendente}, "listEventiDipe.setData(data)");
            if(isA.ListaVoci(listVociDipe)){
                dipeVociSource.fetchData({id_dipte:id_dipendente}, "listVociDipe.setData(data)");
            }
            if(wao.hasDomicilio(id_dipendente)){
                try{tabDomicilioPres.show();}catch(err){}
                dipeDomicilioSource.fetchData({id_dipte:id_dipendente}, "listDomicilioDipe.setData(data)");
            }else{
                try{tabDomicilioPres.hide();}catch(err){}
            }
        }catch(errore){
            wao.log(errore);
        }
    }
    wao.disabilitaScorrimento();
}
