/**
 *  Modulo utenti
 */
function creaGestioneUtenti() {
    if ((wao.up.livello || 40) < 60){
        return false;
    }
    salvaPreferenze = function () {//{{{
        var record = wao._tmp.azienda_last_record || {};
        var aziende = [];
        for (var i = 0 ; i < lstAziende.getTotalRows(); i++){
            var azienda = lstAziende.getEditValues(i);
            if (azienda){
                aziende.push(azienda);
            }
        }
        var dati = {
            utente: wao.getValues(frmUtente.getChangedValues(),['username', 
                'descrizione', 'id', 'codice', 'genitore_id', 'livello', 
                'mesi_password']),
            autorizzazioni: wao.getValues(frmAutorizzazioni.getChangedValues(),
                ['is_presenze', 'is_segreteria', 'auto_presenze',
                'is_ricezione', 'auto_anagrafiche' , 'is_sped_anag', 
                'is_sped_pres']),
            preferenze: lstOpzioni.data,
            azienda_id: record.id,
            utente_id: frmUtente.getValue('id'),
            aziende: aziende
        };
        if (dati.autorizzazioni){
            if (dati.autorizzazioni.auto_presenze === 0){dati.autorizzazioni.auto_presenze = null;}
            if (dati.autorizzazioni.auto_anagrafiche === 0){dati.autorizzazioni.auto_anagrafiche = null;}
        }
        dati.utente.id = dati.utente_id; 
        newSendData({
            url:"app/utenti/aggiorna_utente",
            dati:dati,
            toJSON:true,
            params:{id_genitore: dati.utente.id},
            tipo:"json",
            recordXPath: "utente",
            callback:function(data){
                var utente = data.utente || data;
                var obj = listUtenti.data.find('id', utente.id);
                for (var prop in utente){
                    if (obj.hasOwnProperty(prop)){
                        obj[prop]=utente[prop];
                    }
                }
                listUtenti.redraw();
            }
        });
        lstOpzioni._mchanges = false;
    };//}}}
    studioCambioPassword = function(){//{{{
        var utente = listUtenti.getSelectedRecord();
        if (utente){
            cambioPassword(utente.id);
        }

    };//}}}
    creaNuovoUtente = function(){//{{{
        isc.stdDialog.create({
            ID:"wndCreaUtente",
            title:'Inserimento nuovo utente',
            width: 450,
            height: 150,
            headerIconDefaults:{
                height: 15,
                layoutAlign: "center",
                width: 15,
                src: "/img/icons/user_add.png"
            },
            buttons:[isc.Dialog.CONFIRM,isc.Dialog.CANCEL],
            items:[
                isc.DynamicForm.create({
                    autoDraw:false,
                    titleOrientation:"top",
                    ID:"frmCreaUtente",
                    numCols:2,
                    width:440,
                    autoSize:false,
                    wrapItemTitles:false,
                    //validateOnChange:true,
                    hiliteRequiredFields:true,
                    padding:6,
                    fields:[
                        {name:"username", title:"Username", required:true,colSpan:1,width:340, characterCasing: 'upper', length:50},
                        {name:"codice_utente", title:"Codice", defaultValue:"",width:85, length:7, characterCasing:'upper',
                            keyPressFilter:"[0-9.|a-z.|A-Z.]",
                            validators:[{type:'lengthRange', min:3, max:7}]
                        },
                        {name:"descrizione", title:"Descrizione", width:"*", colSpan:"2", required: true, length:100},
                        {name:"passwd", title:"Password", characterCasing:'upper', type: 'password', required: true, width:"*", colSpan:2,length:30 },
                        {
                            name:"cpasswd",
                            title:"Conferma password",
                            characterCasing: 'upper',
                            type: 'password',
                            required: true,
                            width:"*",
                            colSpan:2,
                            validators: [{
                                 type: "matchesField",
                                 otherField: "passwd",
                                 errorMessage: "La password e la password di conferma non corrispondono"
                             }],
                            length:30
                        }, 
                        { name:"livello", title:"Tipo", type:'integer', disabled:false, _constructor:"SelectItem",
                            defaultToFirstOption: true, required: true,
                            getValueMap: function(){
                                var valueMap = {40:"Utente ditta"};
                                if (wao.up.livello > 99){ valueMap[80] = 'Service'; }
                                if (wao.up.livello > 79 ){ valueMap[60] = 'Studio'; }
                                return valueMap;
                            },
                            changed: function(form, item, value){
                                var f = form.getField('genitore_id');
                                f.setValueMap(form.getField('genitore_id').getValueMap());
                                if (value > 40){
                                    f.title = 'Genitore';
                                }else{
                                    f.title = 'Studio';
                                }
                                f.redraw();
                            }
                        },        
                        { name:"genitore_id", title:"Genitore", type:'integer', disabled:false, _constructor:"SelectItem",
                            defaultToFirstOption: true, required: true,
                            getValueMap: function(){
                                var lista = null;
                                switch (parseInt(this.form.getField('livello').getValue(),10)){
                                    case 40:
                                        lista = listUtenti.getOriginalData().allRows.findAll('livello',60);
                                        break;
                                    case 60:
                                        lista = listUtenti.getOriginalData().allRows.findAll('livello',80);
                                        break;
                                    case 80:
                                        lista = [{id:1,username:'ESSEADMIN','descrizione':'Amministratore Supremo'}];
                                        break;
                                    default:
                                        break;
                                }
                                if (lista === null){
                                    lista = [{id:wao.up.id, username:wao.up.username, descrizione:wao.up.descrizione}];
                                }
                                var valueMap = {};
                                for (var i = 0; i < lista.length; i++){
                                    //valueMap[parseInt(lista[i].id,10)] = lista[i].username + " (" + lista[i].descrizione + ")";
                                    valueMap[lista[i].id] = lista[i].username + " (" + lista[i].descrizione + ")";
                                }
                                return valueMap;
                            }
                        },
                        {
                            titleOrientation:'left',
                            name:"cambio_password",
                            title:"Cambio password ogni (mesi)",
                            type:"integer",
                            defaultValue:"3",
                            textAlign:"right",
                            width:30,
                            length:2
                        }

                    ]
                })
            ],
            confirm: function(){
                if (this.items[0].validate()){
                    var record = this.items[0].getValues();
                    if (confirm("Creare l'utente " + record.username +" ?")){
                        newSendData({
                            url:"app/utenti/crea_utente",
                            params:record,
                            callback:function(data){
                                if (!_lastResponse.hasErrors) {
                                    //utentiSource.fetchData(null, "listUtenti.setData(data);",{blocking: true});
                                    listUtenti.data = [];
                                    listUtenti.fetchData();
                                    wndCreaUtente.hide();
                                }
                            }
                        });
                    }
                    return false;
                }
                return false;
            }
        });
        if (wao.up.livello < 80 ){
            frmCreaUtente.getField('genitore_id').setValue(wao.up.id);
            frmCreaUtente.getField('genitore_id').setDisabled(true);
            frmCreaUtente.getField('livello').setValue(40);
            frmCreaUtente.getField('livello').setDisabled(true);
            frmCreaUtente.getField('codice_utente').hide(true);
        }
    };//}}}
    creaNuovaAzienda = function(){//{{{
        if( frmUtente.getValues().livello != 40){
            isc.say("<p>E' possibile cerare nuove aziende soltamente per gli utenti di gestione.</p>"+
                    "<p>Per creare una nuova azienda selezionare prima l'utente che dovr gestirla</p>");
        }else{
            var id_utente = frmUtente.getValues().id;
            isc.stdDialog.create({
                ID:"wndCreaAzienda",
                title:'Inserimento nuova azienda',
                width: 450,
                height: 150,
                headerIconDefaults:{
                    height: 15,
                    layoutAlign: "center",
                    width: 15,
                    src: "/img/icons/font_add.png"
                },
                buttons:[isc.Dialog.CONFIRM,isc.Dialog.CANCEL],
                items:[
                    isc.DynamicForm.create({
                        autoDraw:false,
                        titleOrientation:"top",
                        numCols:1,
                        width:440,
                        autoSize:false,
                        wrapItemTitles:false,
                        hiliteRequiredFields:true,
                        padding:6,
                        validate:function(){
                            var c = this.getField('codice_ditta').getValue();
                            if (c){
                                c = c.toUpperCase();
                                this.getField('codice_ditta').setValue(c);
                            }
                            return this.Super('validate',arguments);
                        },

                        fields:[
                            {name:'codice_ditta', title:'Codice', required:true, width:90, length:7, characterCasing:'upper',
                                keyPressFilter:"[0-9.|a-z.|A-Z.]",
                                validators:[ {type:'lengthRange', min:6, max:7} ]
                            },
                            {name:'descrizione', title:"Ragione sociale", required:true, width:"*",length:100}
                        ]
                    })
                ],
                confirm: function(){
                    if (this.items[0].validate()){
                        var record = this.items[0].getValues();
                        record.id_utente = id_utente;
                        if (confirm("Creare l'azienda con codice " + record.codice_ditta)){
                            newSendData({
                                url:"app/utenti/crea_ditta",
                                params:record,
                                confermaCallback:{
                                    action:function(){
                                        if(_lastResponse.parsedData){
                                            newSendData({
                                                url:"app/utenti/copia_ditte",
                                                params:{id_utente:id_utente,id_aziende:_lastResponse.parsedData.id_ditta},
                                                callback:function(data){
                                                    if (!_lastResponse.hasErrors && !_lastResponse.hasConferma) {
                                                        lstAziende.fetchData();
                                                        wndCreaAzienda.hide();
                                                    }
                                                }
                                            });
                                        }
                                    }
                                },
                                callback:function(data){
                                    if (!_lastResponse.hasErrors && !_lastResponse.hasConferma) {
                                        lstAziende.fetchData();
                                        wndCreaAzienda.hide();
                                    }
                                }
                            });
                        }
                        return false;
                    }
                    return false;
                }
            });
        }
    };//}}}
    eliminaUtente = function(){//{{{
        if (frmUtente.getValues().livello != 40 && wao.up.livello !== 100){
            isc.say("Possono essere eliminati solo utenti di gestione");
        }else{
            var testo = wao.up.livello == 100 ? "Attenzione si ricorda che eliminare un utente non UtenteAzienza pu generare vari errori!!\n":'';
            testo += "Eliminare l'utente selezionato ?";
            if (confirm(testo)){
                newSendData({
                    url:"app/utenti/elimina_utente",
                    params:{id_utente:frmUtente.getValues().id},
                    //blocking: true,
                    callback: function(data){
                        if (!_lastResponse.hasErrors){
                            //utentiSource.fetchData(null,"listUtenti.setData(data);",{blocking: true});
                            listUtenti.data = [];
                            listUtenti.fetchData();
                        }
                    }
                });
            }
        }
    };//}}}
    eliminaAzienda = function(){//{{{
        var id_ditta;
        if (frmUtente.getValues().livello != 40){
            isc.say("Selezionare prima un utente");
        }else if (!lstAziende.getSelectedRecord()){
            isc.say("Selezionare prima un'azienda");
        }else if(lstAziende.getSelectedRecord().livello !== 0){
            isc.say("Il record selezionato non e' un azienda ma il riferimento per le preferenze dell'utente");
        }else{
            if (confirm("Eliminare l'azienda selezionata ?")){
                newSendData({
                    url:"app/utenti/elimina_ditta",
                    params:{
                        id_utente:frmUtente.getValues().id,
                        id_ditta:lstAziende.getSelectedRecord().id
                    },
                    callback: function(data){
                        if(!_lastResponse.hasErrors){
                            aziendeSource.fetchData(null,function(data){
                                lstAziende.setData(data.data);
                                lstAziende.selectSingleRecord(0);
                                var nrecord = lstAziende.getSelectedRecord();
                                if (nrecord){
                                    lstAziende.rowClick(nrecord,0,0);
                                }else{
                                    lstOpzioni.data = null;
                                    lstOpzioni.redraw();
                                }
                            });
                        }
                    }
                });
            }
        }
    };//}}}
    aziendeDrop = function(aziende,utente){//{{{
        var id_ditta = [];
        if (confirm("Copiare le aziende selezionate nell'utente " + utente.username +" ?" )){
            for (var i = 0; i < aziende.length; i++){
                if (aziende[i].livello === 0){
                    id_ditta.push(aziende[i].id);
                }else{
                   mostraInfo("<b>" + aziende[i].username + "</b> non  un'azienda, non verr copiata");
                }
            }
            newSendData({
                url:"app/utenti/copia_ditte",
                params:{
                    id_aziende : id_ditta,
                    id_utente : utente.id
                }
            });
        }
    };//}}}
    verificaPreferenze = function(callback){//{{{
        if(lstOpzioni.hasChanges() || frmUtente.valuesHaveChanged() || frmAutorizzazioni.valuesHaveChanged() || lstAziende.hasChanges()){
            var recordAzienda = wao._tmp.azienda_last_record;
            var recordUtente = frmUtente.getValues();
            var azienda = '';
            var utente = '';
            if (recordUtente){
                utente = recordUtente.username;
            }
            if (recordAzienda){
                if (recordAzienda.codice.substr(0,1) != "-"){
                    azienda = "<br/>e impostazioni azienda:<br/><b>" + recordAzienda.codice + " - " + recordAzienda.descrizione + '</b>';
                }
            }
            wao.ask("Salvare le modifiche per l'utente <b>" +  utente + '</b> '  + azienda + " ?",{
                action:salvaPreferenze,
                done:callback
            }); 
        }else{
            wao.__fCallback(callback);
        }
    };//}}}
    isc.DataSource.create({//{{{
        ID:'utentiSource',
        dataFormat:"json",
        dataURL: '/app/utenti/getUsersListJ',
        //recordXPath:"/utenti/utente",
        fields:[
            {name:'id',title:'ID', primaryKey:true, required:true, type:"integer" },
            {name:'genitore_id',title:'ID Genitore', required:true, type:"integer"}, 
            {name:'username',title:"Utente",characterCasing:"upper"}, 
            {name:'scad_password',title:"Data Scadenza", type:"date"},
            {name:'mesi_password',title:"Cambio pwd ogni (mesi)", type:"integer",defaultValue:3},
            {name:'codice',title:"Codice Azienda",characterCasing:"upper"},
            {name:'descrizione',title:"Descrizione"},
            {name:'livello',title:"Tipo",type:'integer',  valueMap:{
                100:"Amministratore",
                80:"Service",
                60:"Studio",
                40:"Utente ditta"}
                //0:"Azienda"}
            },
            {name:'auto_presenze',title:"Presenze"},
            {name:'auto_anagrafiche',title:"Anagrafici"},
            {name:'is_segreteria',title:"Segreteria",type:"boolean"},
            {name:'is_sped_anag',title:"Spedizione anagrafiche",type:"boolean"},
            {name:'is_sped_pres',title:"Spedizione presenze",type:"boolean"}
        ]
    });//}}}
    isc.DataSource.create({//{{{
        ID:'aziendeSource',
        dataFormat:"json",
        //recordXPath:"/aziende/azienda",
        dataURL: _gApp("utenti", "getAziendeListUser")
    });//}}}
// Oggetti interfaccia {{{
isc.ListGrid.create({// listUtenti {{{
    ID:"listUtenti",
    autoDraw:false,
    showHeaderContextMenu: false,
    canAcceptDroppedRecords: true,
    saveLocally: true,
    //autoFetchAsFilter: true,
    wrapCells: false,
    //groupByField: 'genitore_id',
    filterOnKeypress: true,
    selectionType:"single",
    emptyMessage:"Nessun utente",
    dataSource:'utentiSource',
    canSort:true,
    sortField:'username',
    autoFetchData: true,
    showFilterEditor: true,
    recordClick:"this.aggiornaEdit()",
    lastCount: 0, 
    fields:[
        {name:"icona", cellIcon:"/img/icons/user_orange.png", type:"icon",width:22,canFilter:false},
        {name:"username", title:"Utente"},
        {name:"descrizione", title:"Descrizione" },
        {name:"codice", title:"Codice"},
        {name:'livello', title:"Tipo", type:"integer", valueMap: {
                100:"Amministratore",
                80:"Service",
                60:"Studio",
                40:"Utente ditta"}
        },
        {name:"genitore_id", title:"Genitore", type:"integer", filterOperator:'equals', valueMap:{}}
    ],
    showRollOverCanvas:true,
    preventClick: false,
    rollOverCanvasConstructor:isc.HLayout,
    rollOverCanvasProperties:{
        snapTo:"R", height:22, width:22,
        members:[
            {_constructor:"Img", src:"/img/icons/autobots-icon.png", 
             click:function(){
                listUtenti.preventClick = true;
                newSendData({
                    url: "app/utenti/trasformazione",
                    params:{id_utente:this.parentElement.record.id},
                    callback: function(data){
                        if (!_lastResponse.hasErrors){
                            document.location="/";
                        }
                        listUtenti.preventClick = false;
                    }
                });
             },
             height:22, width:22}
        ]
    },
    dataArrived: function (startRow, endRow){
        if (isc.getValues(this.getField('genitore_id').valueMap).length !== this.getOriginalData().allRows.length ){
            var d = {};
            d[wao.up.id]=wao.up.username;
            var dd = this.getOriginalData().allRows;
            var c = 0;
            for (var i = 0 ; i < dd.length; i++ ){
                if (dd[i].livello > 40){
                    d[dd[i].id]=dd[i].username;
                    c++;
                }
            }
            if (c !== this.lastCount){
                this.lastCount = c;
                this.setEditorValueMap('genitore_id',d);
                this.setValueMap ('genitore_id',d);
                this.setShowFilterEditor(false);
                this.setShowFilterEditor(true);
            }
        }
    },
    aggiornaEdit : function () {
        if (!this.preventClick){
            var record = this.getSelectedRecord();
            if (record === null) {
                frmUtente.clearValues();
                frmAutorizzazioni.clearValues();
                if (frmGestAziende.getButton(0)){
                    frmGestAziende.getButton(0).setDisabled(true); 
                }
                frmAutorizzazioni.setDisabled(true); 
            } else {
                newSendData({
                    get:{utente_id: record.id},
                    url:"app/utenti/getUserDetails",
                    //blocking: true,
                    callback: function(data){
                        try{frmUtente.editRecord(data);}catch(err){wao.log(err);}
                        try{frmAutorizzazioni.editRecord(data);}catch(err1){wao.log(err1);}
                        frmUtente.getField('codice').setDisabled((data.livello>=40) && (wao.up.livello < 80));
                        frmUtente.getField('username').setDisabled(wao.up.livello < 80);
                        frmUtente.getField('genitore_id').setDisabled(wao.up.livello < 80);
                        frmUtente.getField('livello').setDisabled(wao.up.livello < 80);
                        var f = frmUtente.getField('genitore_id');
                        f.setValueMap(f.getValueMap());
                        if (frmUtente.getField('livello').getValue() > 40){
                            f.title = 'Genitore' ;
                        }else{
                            f.title = 'Studio' ;
                        }
                        f.redraw();
                        if (frmGestAziende.getButton(0)){
                            frmGestAziende.getButton(0).setDisabled(record.livello!=40); 
                        }
                        lstAziende.dataSource = isc.DataSource.create({
                            ID:'aziendeSource',
                            dataFormat:"json",
//                            recordXPath:"/aziende/azienda",
                            fields:[
                                {name:"livello",type:'integer'},
                                {name:"id", type:"integer", primaryKey:true}
                            ]
                        });
                        aziendeSource.dataURL= '/app/utenti/getAziendeListJ?id_utente='+record.id;
                        aziendeSource.fetchData(null,function(data){
                            lstAziende.setData(data.data);
                            lstAziende.selectSingleRecord(0);
                            var nrecord = lstAziende.getSelectedRecord();
                            if (nrecord){
                                lstAziende.rowClick(nrecord,0,0);
                            }else{
                                lstOpzioni.data = null;
                                lstOpzioni.redraw();
                            }
                        });
                        this.acRecord=record;
                    }
                });
            }
        }
    },
    recordDrop: function (dropRecords, targetRecord, index, sourceWidget){
        aziendeDrop(dropRecords,targetRecord);
    }

});//}}}
isc.DynamicForm.create({//{{{
    ID:"frmUtente",
    autoDraw:false,
    numCols:"6",
    fields:[
        { name:"id", primaryKey: true, type: 'integer', required: true, visible: false, disabled: true},
        { name:"username", title:"Utente", _constructor:"TextItem", disabled:true, length:50},
        { name:"descrizione", title:"Descrizione", _constructor:"TextItem", length:100},
        { name:"codice", title:"Codice", _constructor:"TextItem", disabled:true, length:7 },
        { name:"mesi_password", title:"Cambio pwd ogni (mesi)", _constructor:"TextItem", length:2, defaultValue:3 },
        { name:"livello", title:"Tipo", type:'integer', disabled:true, _constructor:"SelectItem",
            defaultToFirstOption: true, required: true,
            getValueMap: function(){
                var valueMap = {40:"Utente ditta"};
                if (wao.up.livello > 99){ valueMap[80] = 'Service'; }
                if (wao.up.livello > 79 ){ valueMap[60] = 'Studio'; }
                return valueMap;
            },
            changed: function(form, item, value){
                var f = form.getField('genitore_id');
                f.setValueMap(form.getField('genitore_id').getValueMap());
                if (value > 40){
                    f.title = 'Genitore' ;
                }else{
                    f.title = 'Studio' ;
                }
                f.redraw();
            }
        },        
        { name:"genitore_id", title:"Genitore", type:'integer', disabled:true, _constructor:"SelectItem",
            defaultToFirstOption: true, required: true, 
            getValueMap: function(){
                var lista = null;
                switch (parseInt(this.form.getField('livello').getValue(),10)){
                    case 40:
                        lista = listUtenti.getOriginalData().allRows.findAll('livello',60);
                        break;
                    case 60:
                        lista = listUtenti.getOriginalData().allRows.findAll('livello',80);
                        break;
                    case 80:
                        lista = [{id:1,username:'ESSEADMIN','descrizione':'Amministratore Supremo'}];
                        break;
                    default:
                        break;
                }
                if (lista === null){
                    lista = [{id:wao.up.id, username:wao.up.username, descrizione:wao.up.descrizione}];
                }
                var valueMap = {};
                for (var i = 0; i < lista.length; i++){
                    valueMap[parseInt(lista[i].id,10)] = lista[i].username + " (" + lista[i].descrizione + ")";
                }
                return valueMap;
            }
        },
    { name:"cambiopasswd", title:"Cambio Password", click:'studioCambioPassword();', align:"center", startRow:false, endRow:false, _constructor:"ButtonItem" }
    ],
    titleOrientation:"left",
    wrapItemTitles:false
});//}}}
isc.ListGrid.create({//{{{
    ID:"lstAziende",
    autoDraw:false,
    showHeaderContextMenu: false,
    emptyMessage:"Nessuna Azienda",
    saveLocally: false,
    autoSaveEdits: false,
    canSort: false,
    canDragRecordsOut: true,
    dragAppearance: "tracker",
    setDragTracker: "isc.Event.setDragTracker(isc.Canvas.imgHTML('/img/icons/font_add.png',24,24))",
    fields:[
        { name:"codice", title:"Codice",width:65 },
        { name:"descrizione", title:"Descrizione", canEdit:true,width:"*" }
    ],
    rowClick: function (record, recordNum, fieldNum){
        if(!wao._tmp.azienda_last_record){
            wao._tmp.azienda_last_record = record;
        }
        var ricarica_preferenze = {
            func:function(record){
                isc.DataSource.create({
                    ID:'preferenzeSource',
                    dataFormat:"json"
                    //recordXPath:"/preferenze_rel/pref"
                });
                try{
                    del_azienda.setDisabled(record.livello!==0); 
                }catch(errore){}
                preferenzeSource.dataURL= _gApp('utenti', 'getUserPref',{
                    id_utente:record.id,
                    id_genitore:frmUtente.getValues().id
                });
                wao._tmp.azienda_last_record = record;
                preferenzeSource.fetchData(null,'lstOpzioni.setData(data);');
                    },
            args:[record],
            obj: lstAziende
        };
        if (lstOpzioni.hasChanges()){
            verificaPreferenze(ricarica_preferenze);
        }else{
            wao.__fCallback(ricarica_preferenze);
        }
    }
});//}}}
 isc.Toolbar.create({//{{{
        ID:"frmGestAziende",
        //buttonConstructor:"IButton",
        buttonDefaults:{
            autoFit: false, 
            height: 22,
            overflow:'visible',
            width:2,
            hiliteAccessKey: true,
            //labelLengthPad:8,
            titleStyle:'styleBottoni'
        },
        width:"100%",
        height: 30,
        align:'right',
        layoutMargin:3,
        autoDraw:false,
        membersMargin: 6,
        buttons:[
            {name:"add_azienda", title:"Aggiungi azienda",  colSpan:1, rowSpan:1, 
                _constructor:"ButtonItem", click:'verificaPreferenze(creaNuovaAzienda);'},
            {ID:"del_azienda", name:"del_azienda", title:"Elimina azienda", _constructor:"ButtonItem",
                click:"verificaPreferenze(eliminaAzienda);"}
        ]
    });//}}}
isc.VLayout.create({//{{{
    ID:"VLayout0",
    autoDraw:false,
    members:[ lstAziende, frmGestAziende ]
});//}}}
isc.ListGrid.create({//{{{
    ID:"lstOpzioni",
    autoDraw:false,
    showHeaderContextMenu: false,
    saveLocally: true,
    emptyMessage:"Nessuna Opzione",
    canEdit: true,
    _mchanges: false,
    hasChanges: function(){
        return this.Super('hasChanges',arguments)|| this._mchanges;
    },
    fields:[
        { name:"nome", title:"Nome" },
        { name:"valore", title:"Valore" }
    ],
    chiediOpzione: function(){
        isc.stdDialog.create({
            ID: "wndOpzioni",
            canDragResize:false,
            title: "Insrimento opzione",
            height:20,
            width:295,
            items:[
                isc.DynamicForm.create({
                    ID:"frmOpzioni",
                    fields:[
                        {name:'nome',title:'Nome',required:true},
                        {name:'valore',title:'Valore'}
                    ]
                })
            ],
            buttons:[
                isc.Dialog.CONFIRM,
                isc.Dialog.CANCEL
            ],
            confirm: function(){
                lstOpzioni.inserisciRecord(frmOpzioni.getValues());
                return true;
            }
        });
        frmOpzioni.getField('nome').focus();
    },
    inserisciRecord: function(valori){
        this.addData(valori);
        this._mchanges = true;
        wndOpzioni.destroy();
    }
});//}}}
isc.Toolbar.create({//{{{
    ID:"DynamicForm4",
    //buttonConstructor:"IButton",
    buttonDefaults:{
        autoFit: false, 
        height: 22,
        overflow:'visible',
        width:2,
        hiliteAccessKey: true,
        //labelLengthPad:8,
        titleStyle:'styleBottoni'
    },
    width:"100%",
    height: 30,
    align:'right',
    layoutMargin:3,
    autoDraw:false,
    membersMargin: 6,
    buttons:[
        { name:"add_opzione", title:"Aggiungi opzione", click:"lstOpzioni.chiediOpzione();", _constructor:"ButtonItem" },
        { name:"del_opzione", title:"Elimina opzione", click:"lstOpzioni.removeData(lstOpzioni.getSelectedRecord());", _constructor:"ButtonItem" }
    ]
});//}}}
isc.VLayout.create({//{{{
    ID:"VLayout2",
    autoDraw:false,
    members:[ lstOpzioni, DynamicForm4 ]
});//}}}
isc.HLayout.create({//{{{
    ID:"HLayout0",
    autoDraw:false,
    members:[ VLayout0, VLayout2 ]
});//}}}
isc.DynamicForm.create({//{{{
    ID:"frmAutorizzazioni",
    autoDraw:false,
    numCols:"4",
    disabled:false,
    fields:[
        { name:"HeaderItem0", defaultValue:"Licenze", _constructor:"HeaderItem" },
        //{ name:"is_presenze", title:"Presenze", type:'boolean',_constructor:"CheckboxItem",defaultValue:true },
        { name:"is_segreteria", title:"Segreteria", type:'boolean', _constructor:"CheckboxItem" },
        { name:"HeaderItem1", defaultValue:"Autorizzazioni", _constructor:"HeaderItem" },
        { name:"auto_presenze", title:"Presenze", _constructor:"SelectItem", valueMap:{
                'A':'Abilita/Aggiorna',
                'C':'Consultazione',
                0:'Non abilitata'
                }
        },
        { name:"is_ricezione", title:"Ricezione", type:'boolean', _constructor:"CheckboxItem" },
        { name:"auto_anagrafiche", title:"Anagrafici", _constructor:"SelectItem", valueMap:{
                'A':'Abilita/Aggiorna',
                'C':'Consultazione',
                0:'Non abilitata'
                }
        },
        { name:"is_sped_anag", title:"Invio_anagrafiche", type:'boolean', _constructor:"CheckboxItem" },
        { name:"is_sped_pres", title:"Invio presenze", type:'boolean', _constructor:"CheckboxItem" }
    ]
});//}}}
isc.TabSet.create({//{{{
    ID:"TabSet0",
    autoDraw:false,
    tabs:[
        { title:"Dati utente", pane:frmUtente, ID:"Tab0" },
        { title:"Impostazioni", pane:HLayout0, ID:"Tab1" },
        { title:"Licenze/Autorizzazioni", pane:frmAutorizzazioni, ID:"Tab2" }
    ],
    destroyPanes:false
});//}}}
isc.VLayout.create({//{{{
    ID:"layUtenti",
    autoDraw:false,
    members:[ listUtenti, TabSet0 ]
});//}}}
// }}}
    wao.getBottoni([
        {title:"Nuovo Utente", click:"verificaPreferenze(creaNuovoUtente);"},
        {title:"Aggiorna", click:"salvaPreferenze()"},
        {title:"Elimina",click:"verificaPreferenze(eliminaUtente)"},
        {title:"Esci", click:"verificaPreferenze('document.location=\"/\"');"}
    ]);
    wao.addSezione('Utenti',layUtenti);
    wao.mostraFiltri(false);
    //listUtenti.fetchData();  
    return true;
}
function mostraUploadLogo(){
    frame_loaded = function(){
        var body = document.getElementById('hidden_frame').contentDocument.body;
        var data = body.innerText || body.textContent;
        data = data.replaceAll(/\n/,'').replaceAll(/\s+/,' ');
        eval(data);
        //gestioneDatiResponse(isc.JSON.decode(data));
    }
    isc.stdDialog.create({
        ID:"wndInviaLogo",
        title:'Invio Logo Studio',
        width: 450,
        height: 150,
        headerIconDefaults:{
            height: 15,
            layoutAlign: "center",
            width: 15,
            src: "/img/icons/user_add.png"
        },
        buttons:[isc.Dialog.CONFIRM,isc.Dialog.CLOSE],
        confirm: function(){
            uploadForm.submitForm();
            return false;
        },
        items:[
            isc.DynamicForm.create({
                ID: "uploadForm",
                target: 'hidden_frame',
                encoding: "multipart",
                wrapItemTitles: false,
                formMethod: 'POST',
                action: "/app/utenti/invia_logo",
                fields: [
                    {name: "Logo", type: "upload", wrap: false}
                ]
            }),
            isc.Label.create({
                height: 30,
                align: "center",
                valign: "center",
                wrap: false,
                padding: 10,
                margin: 10,
                contents: "Inviare solo file in formato png, jpg, gif e bmp"
            }),
                isc.HTMLFlow.create({
                width:1,
                height:1,
                visible: false,
                hidden: true,
                contents:'<iframe id="hidden_frame" name="hidden_frame" onload="frame_loaded();" src="" style="display:none"/>'
            })

        ]
        });
}
